$!
$! Command procedure to assemble and link CAMAC branch driver
$! The parameter required by the command procedure is the highway
$! prefix "xx". The common source file for the CAMAC driver
$! is 'KSDRIVER.MAR'. The generated object,listing, image and
$! map files are consistent with VAX driver naming conventions(i.e.
$! SHDRIVER.* files for serial(SH) driver generation, PHDRIVER.*
$! files for parallel(PH) driver generation.
$!
$ on error then goto abort_gen
$ on control_y then goto abort_gen
$ on severe_error then goto abort_gen
$ if (p1.eqs."") then inquire p1 "Highway prefix??"
$ if (p1.nes."PH") then goto not_ph
$ create 'p1'driver.slp
-2
KS_X_PH		= 1			; PARALLEL DRIVER SWITCH
/
$ goto assemble
$ not_ph:
$ if (p1.nes."SH") then goto not_sh
$ create 'p1'driver.slp
-2
KS_X_SH		= 1			; SERIAL DRIVER SWITCH
/
$ goto assemble
$ not_sh:
$ wr sys$output "Invalid highway prefix ''p1' specified!!"
$ exit
$!
$! Assemble common driver source to produce object file.
$!
$ assemble:
$ assign/user_mode sys$output tt
$ mac/obj='p1'driver/list='p1'driver -
ksdriver.mar/update='p1'driver.slp
$!
$! Link device driver object to produce executable image.
$!
$ assign/user_mode sys$output: tt:
$ create 'p1'driver.opt
base=0
$ link/notrace/map/full 'p1'driver,'p1'driver/opt,sys$system:sys.stb/select
$ del 'p1'driver.opt;,'p1'driver.slp;
$ exit
$!
$! Error exit for error/control_y
$!
$ abort_gen:
$ write sys$output "''p1'DRIVER generation aborted!!"
$ del 'p1'driver.slp;
$ exit
