$! Mount Command File for the CAMAC ACP
$! P1 specifies the CAMAC highway and controller to be "mounted"(eg.
$!	SHA for serial highway controller A, PHA for parellel highway
$!	controller A, etc.)
$! P2(optional) specifies the ACP image file spec to be used during the
$!	mount operation. If not specified, the image file spec defaults
$!	to SYS$SYSTEM:XXACP.EXE where XX=PH for parallel, SH for serial.
$!
$!	Date		By	Change
$!	===========	===	======
$!	3-SEP-1982	ETB	Initial development complete.
$!	16-SEP-1982	ETB	Change input from HSU mnemonic to Hwy ID.
$!	15-DEC-1982	ETB	Add logical name support for desired ACP image.
$!				Change logical name for mount unit.
$!     
$!
$! Privileges required to mount the CAMAC ACP
$!
$ mcam_privs = "cmkrnl,mount,bugchk,detach,altpri,world"
$!
$! Prompt for CAMAC highway ID if not specified.
$!
$ if (p1.eqs."") then inquire p1 "CAMAC Highway ID?"
$ if (p2.nes."") then goto mount_unit
$ p2 := sys$system:'f$extract(0,2,p1)'camacp.exe
$ mount_unit:
$ set nocontrol=(t,y)
$!
$! Set to invoke mount image
$!
$ prev_priv := 'f$setprv(mcam_privs)
$ assign/user_mode  'p1'0: mcam$unit
$ assign/user_mode 'p2' mcam$image
$ on error then goto mcam_error
$ on severe_error then goto mcam_error
$ mc mountcam
$ mcam_error:
$ set control=(t,y)
$ junk := 'f$setprv(prev_priv)
$ exit
