	program l8801m4
	implicit integer(a-z)
	parameter maxb=4096			! max xfer size(bytes)
	parameter max16=maxb/2			! max xfer size(i*2)
	parameter max24=maxb/4			! max xfer size(i*4)
c++
c
c	Execute and reply list parameters
c	To aviod confusion and possible programming errors, 
c	execute list and reply list buffers should be declared 
c	as INTEGER*2 arrays. The length parameters defined below 
c	are generated to adhere to this convention. There is no 
c	real restriction on type for execute list or reply list 
c	bufffers, however.
c
c--
	parameter exe_hdrlen=10			! exe list hdr len(i*2 count)
	parameter exe_maxcmd=10			! max command frame count
	parameter exe_datal=maxb/2+8		! exe list data(i*2 count)
	parameter exe_length=exe_hdrlen+
	9		exe_maxcmd*3+
	9		exe_datal		! exe list length(i*2 count)
	parameter rep_length=maxb/2+8		! rep list length(i*2)
	parameter mem_w=16			! 16 bit memory format
c++
c
c	Execute and reply list declarations
c	Note: The execute list and reply list buffers are declared
c	as zero relative arrays to allow the direct use of FIB pointers
c	(if so desired) without offseting by 1 to compensate for the
c	indexing convention utilized by the CAMAC access software.
c
c--
	integer*2 exe_list(0:exe_length),rep_List(0:rep_length)
c++
c
c	Frame Information Block(FIB) parameters
c
c--
	parameter fib_length=4			! FIB struc length(i*2)
	parameter fib_w_cndx=1			! FIB command index offset
	parameter fib_b_fcode=2			! FIB fcode offset
	parameter fib_w_dndx=3			! FIB data index offset
	parameter fib_w_dsiz=4			! FIB data size offset
c++
c
c	FIB List(FIBL) for the execute list.
c
c	FIB list entries are indexed by the command frame number.
c	The symbolic offsets(defined as parameters) are used to
c	reference the fields of the FIB data structure for a given
c	command frame.
c
c--
	integer*2 fib_list(fib_length,exe_maxcmd)
c++
c
c	Define program local CAMAC I/O status block
c
c--
	integer*4 iosb(2)
c++
c
c	Working data buffers to use for manipulating CAMAC read
c	and write data vs. actually referencing the data in the
c	reply and execute list buffers.
c
c--
	integer*2 caminp(max16),camout(max16)
c++
c
c	Use CHARACTER variables for logical module names.
c
c--
	character*32 logmod
c++
c
c	Misc. declarations
c
c--
	logical*4 cam$go
	data map/0/

c++
c
c	Prompt user for logical module name.
c
c--
	type 1999
1999	format(1x,'Enter lrs 8801 module ',$)
	accept 1998,loglen,logmod
1998	format(q,a)
	if (loglen.eq.0) call exit
c++
c
c	Assign key to the LRS 8801 module.
c
c--
	status=cam$assign(logmod,keyv)
	if (.not.status) then
		call lib$stop(%val(status))
	end if
c++
c
c	Prompt user for desired transfer count.
c
c--
3001	continue
	type 1995,max16
1995	format(1x,'Enter transfer count;',i,' limit ',$)
	accept	*,tc
	if (tc.le.0 .or. tc.gt.max16) then
		type 1993,tc
		go to 3001
	end if
1993	format(1x,'Invalid transfer count=',i)
c++
c
c	Initialize the LRS 8801 module using non-list
c	mode CAMAC access calls.
c	Perform a module clear(A0,F9),
c	Disable the external memory port(A0,F19),
c	Enable auto-increment mode for the MAP(A0,F25).
c
c--
	a=0
	f=9
	status=cam$piow(%descr(keyv),a,f,,,iosb)
	if (.not.cam$go(status,iosb)) call exit
	f=19
	status=cam$piow(%descr(keyv),a,f,0,16,iosb)
	if (.not.cam$go(status,iosb)) call exit
	f=25
	status=cam$piow(%descr(keyv),a,f,,,iosb)
	if (.not.cam$go(status,iosb)) call exit
c++
c
c	Initialize the execute list buffer
c	This call sets up the execute list header(actually
c	part of the execute list itself) and readies it to
c	receive command and data frames generated by CAMAC
c	command list calls. Things to note include:
c		1. The execute list buffer length is specified
c		   in I*2 units(i.e. words).
c		2. The memory format(defined as a parameter in
c		   this case) applies to all CAMAC operations
c		   from the list, both read and write.
c		3. A FIBL is attached for this execute list buffer.
c
c--
	call cam$dclst(exe_list,exe_length,mem_w,fib_list)
c++
c
c*** Frame 1
c	Generate a list programmed I/O command and data frames 
c	to reset the LRS 8801 MAP. The value in the variable 
c	MAP is copied into the data frame for the programmed
c	I/O operation.
c
c--
	f=18
	status=cam$lpio(exe_list,%descr(keyv),a,f,map)
	if (.not.status) then
		call lib$stop(%val(status))
	end if
c++
c
c*** Frame 2
c	Generate a list Stop mode command frame to write the
c	a data frame to the LRS 8801 module. No data is actually
c	copied to the data frame in this case, however. Space
c	is reserved in the execute list buffer for the specified
c	amount of data. The transfer count(TC) is in units of the
c	memory format associated with the execute list buffer.
c
c--
	f=16
	status=cam$lstop(exe_list,%descr(keyv),a,f,tc)
	if (.not.status) then
		call lib$stop(%val(status))
	end if
c++
c
c*** Frame 3
c	Generate list PIO command frame and data frame to write the
c	LRS 8801 MAP register in preparation for reading back the
c	data buffer previously written to the module.
c
c--
	f=18
	status=cam$lpio(exe_list,%descr(keyv),a,f,map)
	if (.not.status) then
		call lib$stop(%val(status))
	end if
c++
c
c*** Frame 4
c	Generate a list PIO command frame to perform a read 
c	operation to the LRS 8801 module to prime the module for 
c	a block transfer. Otherwise, the first two words returned 
c	from the module in the block transfer will be the same.
c
c--
	f=2
	status=cam$lpio(exe_list,%descr(keyv),a,f)
	if (.not.status) then
		call lib$stop(%val(status))
	end if
c++
c
c*** Frame 5
c	Generate a list Stop mode command frame to read the data
c	written to the LRS 8801 module. 
c
c--
	status=cam$lstop(exe_list,%descr(keyv),a,f,tc)
	if (.not.status) then
		call lib$stop(%val(status))
	end if
c++
c
c	LRS 8801 test loop
c
c--
4001	continue
c++
c
c	Generate data pattern to write to LRS 8801
c
c--
	call gen16(camout,tc)
c
c	Update data for frame 2 of execute list
c
c--
	call cam$wdata(exe_list,2,camout)
c++
c
c	Execute command list
c
c--
	status=cam$executew(exe_list,rep_list,rep_length,iosb)
	if (.not.cam$go(status,iosb)) call exit
c++
c
c	Retrieve read data for frame 5 from reply list
c
c--
	call cam$rdata(exe_list,5,rep_list,caminp)
c++
c
c	Verify CAMAC data read from LRS 8801 with data written to
c	LRS 8801.
c
c--
	call verify(camout,caminp,tc)
	go to 4001
	end
	logical function cam$go(status,iosb)
	implicit integer(a-z)
	integer*4 iosb(*),liosb(2)
	logical*4 cam$error
	character response*4
c++
c
c	Assume failure.
c
c--
	cam$go=.false.
c++
c
c	Determine if system error occurred. If so, signal
c	the error condition and if control returns, go prompt
c	for desired action.
c
c--
	if (.not.status) then
		call lib$signal(%val(status))
		go to 1001
	end if
c++
c
c	If the IOSB is specified as null, sample the CAMAC image block
c	IOSB value, else, use the specified IOSB buffer.
c
c--
	if (%loc(iosb).eq.0) then
		call cam$get_stat(liosb)
	else
		liosb(1)=iosb(1)
		liosb(2)=iosb(2)
	end if
c++
c
c	Determine if a CAMAC error occurred. If so, display
c	the CAMAC I/O status block contents and then go prompt
c	for desired action.
c
c--
	if (cam$error(,,liosb)) then
		call cam$show_stat(liosb)
		go to 1001
	end if
c++
c
c	Change assumed failure to success and return.
c
c--
	cam$go=.true.
	return
c++
c
c	Manual override of failure status?
c
c--
1001	continue
	type 1999
1999	format(1x,'Override failure? Y/N[N] ',$)
	accept 1998,resp_len,response
1998	format(q,a)
	if (resp_len.eq.1 .and. 
	9	(response(1:1).eq.'y' .or.
	9	response(1:1).eq.'Y')) cam$go=.true.
	return
	end
	subroutine gen16(camout,tc)
	implicit integer(a-z)
	integer*2 camout(1)
	integer*2 tpat16/'3333'x/
c++
c
c	Generate a test pattern into the specified INTEGER*2
c	buffer according to the length specified by the transfer
c	count variable(TC). The test pattern is replaced by it's
c	ones complement after the buffer is loaded.
c
c--
	do tndx=1,tc
	camout(tndx)=tpat16
	end do
	tpat16=-tpat16-1
	return
	end
	subroutine verify(outdat,inpdat,wc)
	implicit integer(a-z)
	integer*2 outdat(*),inpdat(*)
c++
c
c	Verify each INTEGER*2 element of the specified output
c	data buffer aganist each element of the specified INTEGER*2 
c	input data buffer according to the length specified by the
c	word count variable(WC). The verification terminates at the
c	first data mismatch.
c
c--
	do ndx=1,wc
	if (inpdat(ndx).ne.outdat(ndx)) then
		type 1999,ndx,outdat(ndx),inpdat(ndx)
		return
	end if
	end do
1999	format(1x,'Pos=',i,' Output=',z4,' Input=',z4)
	return
	end
