C++
C
C	This benchmark is designed to generate performance data
C	for CAMAC Programmed I/O(PIO) requests using both direct
C	module reference and keyed module reference call formats.
C	The program consists of three loops. The first loop guages
C	the execution of the status checking that follows each 
C	CAMAC call. The second loop guages the execution of a CAM$PIOW
C	CAMAC call with direct module reference. The third loop guages the
C	execution of a CAM$PIOW call with keyed module reference.
C
C--
	PROGRAM BENCHAM0
	IMPLICIT INTEGER(A-Z)
	EXTERNAL SS$_NORMAL
	PARAMETER CMAX=1000
	CHARACTER*32 LOGMOD
	LOGICAL*4 CAM$ERROR
	INTEGER*4 IOSB(2)
	DATA A/0/,F/16/
	TYPE *,'VAX CAM$PIOW BENCHMARK-WRITE TEST'
C++
C
C	PROMPT USER FOR LOGICAL MODULE NAME
C
C--
	TYPE 1999
1999	FORMAT(1X,'ENTER MODULE NAME ',$)
	ACCEPT 1998,LOGLEN,LOGMOD
1998	FORMAT(Q,A)
	IF (LOGLEN.EQ.0) CALL EXIT
C++
C
C	ASSIGN KEY VALUE TO LOGICAL MODULE
C
C--
	STATUS=CAM$ASSIGN(LOGMOD(1:LOGLEN),KEYV)
	IF (STATUS.NE.%LOC(SS$_NORMAL)) THEN
		CALL LIB$STOP(%VAL(STATUS))
	END IF
C++
C
C	GUAGE CAMAC STATUS TESTS
C
C--
	IOSB(1)=%LOC(SS$_NORMAL)
	IOSB(2)=0
	TYPE 1997,'GUAGE CAMAC STATUS TESTING',CMAX
1997	FORMAT(1X,A,' :LOOP COUNT=',I)
	CALL LIB$INIT_TIMER
	DO COUNT=1,CMAX
	IF (STATUS.NE.%LOC(SS$_NORMAL)) THEN
		TYPE *,'INIT FAILURE'
		CALL EXIT
	END IF
	IF (CAM$ERROR(,,IOSB)) THEN
		TYPE *,'INIT FAILURE'
		CALL EXIT
	END IF
	END DO
	CALL LIB$SHOW_TIMER
C++
C
C	GUAGE PIO REQUEST USING DIRECT MODULE ACCESS
C
C--
	TYPE 1997,'GUAGE CAM$PIOW W/DIRECT REFERENCE',CMAX
	CALL LIB$INIT_TIMER
	DO COUNT=1,CMAX
	STATUS=CAM$PIOW(LOGMOD(1:LOGLEN),A,F,DATA,24,IOSB)
	IF (STATUS.NE.%LOC(SS$_NORMAL)) THEN
		CALL LIB$SIGNAL(%VAL(STATUS))
		CALL EXIT
	END IF
	IF (CAM$ERROR(,,IOSB)) THEN
		TYPE 1992,IOSB
		CALL EXIT
	END IF
	END DO
	CALL LIB$SHOW_TIMER
C++
C
C	GUAGE PIO REQUEST USING KEYED MODULE ACCESS
C
C--
	TYPE 1997,'GUAGE CAM$PIOW W/KEYED REFERENCE',CMAX
	CALL LIB$INIT_TIMER
	DO COUNT=1,CMAX
	STATUS=CAM$PIOW(%DESCR(KEYV),A,F,DATA,24,IOSB)
	IF (STATUS.NE.%LOC(SS$_NORMAL)) THEN
		CALL LIB$SIGNAL(%VAL(STATUS))
		CALL EXIT
	END IF
	IF (CAM$ERROR(,,IOSB)) THEN
		TYPE 1992,IOSB
		CALL EXIT
	END IF
1992	FORMAT(1X,'IOSB= ',Z8,2X,Z8)
	END DO
	CALL LIB$SHOW_TIMER
	CALL EXIT
	END
