C++
C
C	This benchmark is designed to generate performance data
C	for CAMAC STOP mode data transfers using both direct module
C	access format and keyed module access format CAM$STOPW
c	CAMAC calls. The program benchmarks three loops. The first
C	loop guages the status checking overhead for each CAMAC
C	call. The second loop guages the execution of a CAM$STOPW CAMAC
C	call using direct module reference. The third loop guages the
C	execution of a CAM$STOPW CAMAC call using keyed module reference.
C
C--
	PROGRAM BENCHAM3
	IMPLICIT INTEGER(A-Z)
	EXTERNAL SS$_NORMAL
	PARAMETER CMAX=1000
	CHARACTER*32 LOGMOD
	LOGICAL*4 CAM$ERROR
	INTEGER*4 IOSB(2)
	DATA TC/1/,A/0/,F/16/
	TYPE *,'VAX CAM$STOPW BENCHMARK-WRITE TEST'
C++
C
C	PROMPT USER FOR LOGICAL MODULE NAME
C
C--
	TYPE 1999
1999	FORMAT(1X,'ENTER MODULE NAME ',$)
	ACCEPT 1998,LOGLEN,LOGMOD
1998	FORMAT(Q,A)
	IF (LOGLEN.EQ.0) CALL EXIT
C++
C
C	ASSIGN KEY VALUE TO LOGICAL MODULE
C
C--
	STATUS=CAM$ASSIGN(LOGMOD(1:LOGLEN),KEYV)
	IF (STATUS.NE.%LOC(SS$_NORMAL)) THEN
		CALL LIB$STOP(%VAL(STATUS))
	END IF
C++
C
C	GUAGE CAMAC STATUS TESTS
C
C--
	IOSB(1)=1
	IOSB(2)=0
	TYPE 1997,'GUAGE CAMAC STATUS TESTING',CMAX
1997	FORMAT(1X,A,' :LOOP COUNT=',I)
	CALL LIB$INIT_TIMER
	DO COUNT=1,CMAX
	IF (STATUS.NE.%LOC(SS$_NORMAL)) THEN
		TYPE *,'INIT FAILURE'
		CALL EXIT
	END IF
	IF (CAM$ERROR(,,IOSB)) THEN
		TYPE *,'INIT FAILURE'
		CALL EXIT
	END IF
	END DO
	CALL LIB$SHOW_TIMER
C++
C
C	GUAGE STOP MODE REQUEST USING DIRECT MODULE ACCESS
C
C--
	TYPE 1997,'GUAGE CAM$STOPW W/DIRECT REFERENCE',CMAX
	CALL LIB$INIT_TIMER
	DO COUNT=1,CMAX
	STATUS=CAM$STOPW(LOGMOD(1:LOGLEN),A,F,TC,DATA,24,IOSB)
	IF (STATUS.NE.%LOC(SS$_NORMAL)) THEN
		CALL LIB$SIGNAL(%VAL(STATUS))
		CALL EXIT
	END IF
	IF (CAM$ERROR(,,IOSB)) THEN
		TYPE 1992,IOSB
		CALL EXIT
	END IF
	END DO
	CALL LIB$SHOW_TIMER
C++
C
C	GUAGE STOP MODE REQUEST USING KEYED MODULE ACCESS
C
C--
	TYPE 1997,'GUAGE CAM$STOPW W/KEYED REFERENCE',CMAX
	CALL LIB$INIT_TIMER
	DO COUNT=1,CMAX
	STATUS=CAM$STOPW(%DESCR(KEYV),A,F,TC,DATA,24,IOSB)
	IF (STATUS.NE.%LOC(SS$_NORMAL)) THEN
		CALL LIB$SIGNAL(%VAL(STATUS))
		CALL EXIT
	END IF
	IF (CAM$ERROR(,,IOSB)) THEN
		TYPE 1992,IOSB
		CALL EXIT
	END IF
1992	FORMAT(1X,'IOSB= ',Z8,2X,Z8)
	END DO
	CALL LIB$SHOW_TIMER
	CALL EXIT
	END
