C++
C
C	This program is a simple, single module CAMAC exercisor for use
C	with the FED VAX CAMAC system. The program enables the user to
C	specify the logical module to be exercised and then enters a
C	subaddress, function code request loop enabling a sequence of
C	CAMAC transactions to the module. Each transaction is performed
C	as a single-action CAMAC request(non-DMA type operation).
C	Following the execution of the CAMAC request, the X and
C	Q responses are displayed as logical outputs(T/F). If
C	the CAMAC function code indicates a data write operation,
C	the user is prompted for input(hexadecimal format) before
C	the operation takes place. If the CAMAC function code indicates
C	a data read operation, the resulting data is displayed
C	following the X and Q status display. To exit the (A,F)
C	loop, a '-1' subaddress or function code may be entered.
C	Upon such input, the user is prompted for another CAMAC
C	module name to exercise. A carriage return will cause the
C	program to exit.
C
C--
	PROGRAM TESTPIO
	IMPLICIT INTEGER(A-Z)
	CHARACTER LOGMOD*32,RESPONSE*32
	LOGICAL*4 CAM$ERROR,CAM$X,CAM$Q
	LOGICAL*4 XVAL,QVAL
	INTEGER*4 IOSB(2)
	WRITE(*,*) 'VAX CAMAC MODULE EXERCISOR'
C++
C
C	PROMPT USER FOR LOGICAL MODULE NAME
C
C--
1001	CONTINUE
	WRITE(*,1999)
1999	FORMAT(1X,'ENTER MODULE NAME; ^Z TO EXIT ',$)
	READ(*,1998,END=9999) RESP_LEN,RESPONSE
1998	FORMAT(Q,A32)
C++
C
C	ASSIGN KEY VALUE TO LOGICAL MODULE
C
C--
	STATUS = CAM$ASSIGN (RESPONSE (1:RESP_LEN), KEYV)
	IF (.NOT.STATUS) THEN
		CALL LIB$STOP(%VAL(STATUS))
	END IF
C++
C
C	SUBADDRESS, FUNCTION CODE REPETITION LOOP
C
C--
2001	CONTINUE
	WRITE(*,1996)
1996	FORMAT(1X,'ENTER SUBADDRESS, FUNCTION CODE; ^Z TO EXIT ',$)
	READ(*,1995,END=4001) A,F
1995	FORMAT(2I)
C++
C
C	PROMPT FOR DATA IF CAMAC WRITE OPERATION.
C
C--
	IF (F.GE.16 .AND. F.LE.23) THEN
		WRITE(*,1994)
		READ(*,1993) DATA
	END IF
1994	FORMAT(1X,'ENTER WRITE DATA(Z FORMAT)',$)
1993	FORMAT(Z)
C++
C
C	PERFORM SINGLE ACTION CAMAC REQUEST.
C
C--
	STATUS=CAM$PIOW(%DESCR(KEYV),A,F,DATA,24,IOSB)
	IF (.NOT.STATUS) THEN
		CALL LIB$SIGNAL(%VAL(STATUS))
		GO TO 1001
	END IF
	IF (CAM$ERROR(,,IOSB)) THEN
		CALL CAM$SHOW_STAT(IOSB)
		GO TO 2001
	END IF
C++
C
C	DISPLAY CAMAC X AND Q VALUES.
C
C--
	XVAL=CAM$X(IOSB)
	QVAL=CAM$Q(IOSB)
	WRITE(*,1989) XVAL,QVAL
1989	FORMAT(1X,'X =',L,' Q=',L)
C++
C
C	DISPLAY DATA IF CAMAC READ OPERATION INDICATED.
C
C--
	IF (XVAL .AND. F.LE.7) THEN
		WRITE(*,1991) DATA,DATA
	END IF
1991	FORMAT(1X,'READ DATA=',Z8,' HEX; ',I,' DECIMAL')
	GO TO 2001
C++
C
C	EXIT SUBADDRESS, FUNCTION EXERCISE LOOP. DEASSIGN MODULE KEY AND
C	GO PROMPT FOR ANOTHER MODULE TO TEST.
C
C--
4001	CONTINUE
	STATUS=CAM$DASSGN(KEYV)
	IF (.NOT.STATUS) THEN
		CALL LIB$SIGNAL(%VAL(STATUS))
	END IF
	GO TO 1001
C++
C
C	EXIT PROGRAM
C
C--
9999	CONTINUE
	CALL EXIT
	END
