C++
C
C	This program is designed to exercise the STOP mode CAMAC 
C	access call in the VAX CAMAC library. The program utilizes
C	a Le Croy Systems 8801/16 memory moduule.
C	The program performs the following steps to verify
C	STOP mode operation.
C
C		1. Clear the LRS 8801 module.
C		2. Disable the LRS 8801 external port.
C		3. Enable auto-increment mode for the LRS 8801
C			memory address pointer.
C		4. Write an initial address pointer to the LRS 8801 MAP.
C		5. Write a block of data to the LRS 8801 memory module
c			using the CAM$QSTOP access procedure.
C		6. Reset the LRS 8801 MAP to the initial address.
C		7. Read back the last write data to the LRS 8801.
C		8. Read the block of data written to the LRS 8801.
C		9. Verify that the data read from the LRS 8801 is the
C			same data written to the module.
C		10. Loop back to step 4 and repeat.
C
C--
	PROGRAM L8801M3
	IMPLICIT INTEGER(A-Z)
	EXTERNAL SS$_NORMAL
	PARAMETER MAXB=4096
	PARAMETER MAX16=MAXB/2
	PARAMETER MAX24=MAXB/4
	INTEGER*4 CAMINP(MAX24),CAMOUT(MAX24)
	INTEGER*2 CAMINP_16(MAX16),CAMOUT_16(MAX16)
	EQUIVALENCE (CAMINP,CAMINP_16),(CAMOUT,CAMOUT_16)
	INTEGER*4 CAMSTATUS(3),IOSB(2)
	EQUIVALENCE(CAMSTATUS(1),STATUS),(CAMSTATUS(2),IOSB)
	CHARACTER*32 LOGMOD
	CHARACTER*4 INP
	LOGICAL*4 CAM$GO
	DATA MAP/0/
C++
C
C	PROMPT USER FOR LOGICAL MODULE NAME.
C
C--
	TYPE 1999
1999	FORMAT(1X,'ENTER LRS 8801 MODULE NAME ',$)
	ACCEPT 1998,LOGLEN,LOGMOD
1998	FORMAT(Q,A32)
	IF (LOGLEN.EQ.0) CALL EXIT
C++
C
C	ASSIGN KEY TO MODULE FOR KEYED ACCESS.
C
C--
	STATUS=CAM$ASSIGN(LOGMOD,KEYV)
	IF (STATUS.NE.%LOC(SS$_NORMAL)) THEN
		CALL LIB$STOP(%VAL(STATUS))
	END IF
	TYPE 1985,LOGMOD(1:LOGLEN),KEYV
1985	FORMAT(1X,'MODULE: ',A,' KEY VALUE=',Z8)
C++
C
C	PROMPT USER FOR DESIRED MEMORY FORMAT.
C
C--
2001	CONTINUE
	TYPE 1997
1997	FORMAT(1X,'ENTER 16 OR 24 BIT MEMORY FORMAT ',$)
	ACCEPT 1996,MEM
1996	FORMAT(I)
	TCMAX=-1
	IF (MEM.EQ.16) TCMAX=MAX16
	IF (MEM.EQ.24) TCMAX=MAX24
	IF (TCMAX.LT.0) THEN
		TYPE 1994,MEM
		GO TO 2001
	END IF
1994	FORMAT(1X,'INVALID MEMORY FORMAT=',I)
C++
C
C	PROMPT USER FOR DESIRED TRANSFER COUNT.
C
C--
3001	CONTINUE
	TYPE 1995,TCMAX
1995	FORMAT(1X,'ENTER TRANSFER COUNT;',I,' LIMIT ',$)
	ACCEPT	1996,TC
	IF (TC.LE.0 .OR. TC.GT.TCMAX) THEN
		TYPE 1993,TC
		GO TO 3001
	END IF
1993	FORMAT(1X,'INVALID TRANSFER COUNT=',I)
C++
C
C	CLEAR LRS 8801 MEMORY MODULE.
C
C--
	A=0
	F=9
	STATUS=CAM$PIOW(%DESCR(KEYV),A,F,,,IOSB)
	IF (.NOT.CAM$GO(CAMSTATUS)) GO TO 2001
D	TYPE *,'MEM CLEAR'
D	ACCEPT *,MORE
C++
C
C	DISABLE LRS 8801 EXTERNAL MEMORY PORT.
C
C--
	F=19
	STATUS=CAM$PIOW(%DESCR(KEYV),A,F,0,24,IOSB)
	IF (.NOT.CAM$GO(CAMSTATUS)) GO TO 2001
D	TYPE *,'DABL EXP'
D	ACCEPT *,MORE
C++
C
C	ENABLE AUTO-INCREMENT FOR LRS 8801 MAP.
C
C--
	F=25
	STATUS=CAM$PIOW(%DESCR(KEYV),A,F,,,IOSB)
	IF (.NOT.CAM$GO(CAMSTATUS)) GO TO 2001
D	TYPE *,'EABL AINC'
D	ACCEPT *,MORE
C++
C
C	LRS 8801 STOP MODE TEST LOOP.
C
C--
4001	CONTINUE
C++
C
C	GENERATE ALTERNATING DATA PATTERN FOR
C	LRS 8801 TEST.
C
C--
	IF (MEM.EQ.16) CALL GEN16(CAMOUT_16,TC)
	IF (MEM.EQ.24) CALL GEN24(CAMOUT,TC)
C++
C
C	SET LRS 8801 MAP TO INITIAL VALUE.
C
C--
	F=18
	STATUS=CAM$PIOW(%DESCR(KEYV),A,F,MAP,24,IOSB)
	IF (.NOT.CAM$GO(CAMSTATUS)) GO TO 2001
D	TYPE *,'WRITE MAP'
D	ACCEPT *,MORE
C++
C
C	WRITE DATA BUFFER TO LRS 8801 USING STOP MODE
C	CAMAC REQUEST.
C
C--
	F=16
	STATUS=CAM$STOPW(%DESCR(KEYV),A,F,TC,CAMOUT,MEM,IOSB)
	IF (.NOT.CAM$GO(CAMSTATUS)) GO TO 2001
D	TYPE *,'WRITE DATA'
D	ACCEPT *,MORE
C++
C
C	RESET LRS 8801 MAP TO READ DATA BACK.
C
C--
	F=18
	STATUS=CAM$PIOW(%DESCR(KEYV),A,F,MAP,24,IOSB)
	IF (.NOT.CAM$GO(CAMSTATUS)) GO TO 2001
D	TYPE *,'READ MAP'
D	ACCEPT *,MORE
C++
C
C	READ BACK LAST DATA WRITTEN TO LRS 8801.
C
C--
	F=2
	STATUS=CAM$PIOW(%DESCR(KEYV),A,F,DUMY,MEM,IOSB)
	IF (.NOT.CAM$GO(CAMSTATUS)) GO TO 2001
D	TYPE *,'READ DUMMY'
D	ACCEPT *,MORE
C++
C
C	READ BACK DATA WRITTEN TO LRS 8801 USING STOP MODE
C	CAMAC REQUEST.
C
C--
	STATUS=CAM$STOPW(%DESCR(KEYV),A,F,TC,CAMINP,MEM,IOSB)
	IF (.NOT.CAM$GO(CAMSTATUS)) GO TO 2001
D	TYPE *,'READ DATA'
D	ACCEPT *,MORE
C++
C
C	VERIFY DATA READ AGANIST DATA WRITTEN ACCORDING TO
C	MEMORY FORMAT SELECTED.
C
C--
	IF (MEM.EQ.16) CALL VER16(CAMINP_16,CAMOUT_16,TC)
	IF (MEM.EQ.24) CALL VER24(CAMINP,CAMOUT,TC)
	GO TO 4001
	END
	LOGICAL FUNCTION CAM$GO(CAMSTATUS)
	IMPLICIT INTEGER(A-Z)
	INTEGER*4 CAMSTATUS(*)
	LOGICAL*4 CAM$ERROR,CAM$X
C++
C
C	ASSUME FAILURE BY SETTING 'GO' FALSE.
C
C--
	CAM$GO=.FALSE.
C++
C
C	TEST RETURN SYSTEM STATUS FROM CAMAC CALL
C
C--
	IF (.NOT.CAMSTATUS(1)) THEN
		CALL LIB$SIGNAL(%VAL(CAMSTATUS(1)))
		RETURN
	END IF
C++
C
C	IF SYSTEM STATUS NORMAL, THEN TEST FOR CAMAC TRANSMISSION
C	ERROR VIA CAM$ERROR PROCEDURE CALL.
C
C--
	IF (CAM$ERROR(,,CAMSTATUS(2))) THEN
		CALL CAM$SHOW_STAT(CAMSTATUS(2))
		RETURN
	END IF
C++
C
C	IF NO TRANSMISSION ERROR, THEN TEST FOR VALID
C	CAMAC X RESPONSE FROM CAMAC ACCESS CALL.
C
C--
	IF (.NOT.CAM$X(CAMSTATUS(2))) THEN
		CALL CAM$SHOW_STAT(CAMSTATUS(2))
		RETURN
	END IF
C++
C
C	CHANGE ASSUMED FAILURE INTO SUCCESS AND RETURN
C
C--
	CAM$GO=.TRUE.
	RETURN
	END
	SUBROUTINE GEN16(CAMOUT,TC)
	IMPLICIT INTEGER(A-Z)
	INTEGER*2 CAMOUT(1)
	INTEGER*2 TPAT16/'3333'X/
C++
C
C	GENERATE TEST DATA FROM 16-BIT TEST PATTERN AND
C	THEN REPLACE TEST PATTERN WITH IT'S ONES COMPLEMENT.
C
C--
	DO TNDX=1,TC
	CAMOUT(TNDX)=TPAT16
	END DO
	TPAT16=-TPAT16-1
	RETURN
	END
	SUBROUTINE GEN24(CAMOUT,TC)
	IMPLICIT INTEGER(A-Z)
	INTEGER*4 CAMOUT(1)
	DATA TPAT24/'3333'X/
	DATA LOW16/'FFFF'X/
C++
C
C	GENERATE TEST DATA FROM 24-BIT TEST PATTERN AND THEN
C	REPLACE TEST PATTERN WITH IT'S ONES COMPLEMENT. 
C
C	NOTE THAT THE 24-BIT DATA GENERATED CONSISTS OF A 16-BIT
C	DATA PATTERN, ZERO EXTENDED TO 24-BITS. ALSO, NOTE
C	THAT EACH 24-BIT DATA WORD FOR CAMAC REQUIRES A LONGWORD OF
C	VAX STORAGE.
C
C--
	DO TNDX=1,TC
	CAMOUT(TNDX)=TPAT24
	END DO
	TPAT24=(-TPAT24-1) .AND. LOW16
	RETURN
	END
	SUBROUTINE VER16(CAMINP,CAMOUT,TC)
	IMPLICIT INTEGER(A-Z)
	INTEGER*2 CAMINP(1),CAMOUT(1)
C++
C
C	VERIFY 16-BIT INPUT DATA BUFFER WITH 16-BIT OUTPUT
C	DATA BUFFER FOR THE LENGTH SPECIFIED BY THE TRANSFER 
C	COUNT VARIABLE.
C
C--
	DO TNDX=1,TC
	IF (CAMINP(TNDX).NE.CAMOUT(TNDX)) THEN
		TYPE 1999,TNDX,CAMOUT(TNDX),CAMINP(TNDX)
		RETURN
	END IF
	END DO
1999	FORMAT(1X,'NDX=',I,' OUTPUT=',Z4,' INPUT=',Z4)
	RETURN
	END
	SUBROUTINE VER24(CAMINP,CAMOUT,TC)
	IMPLICIT INTEGER(A-Z)
	INTEGER*4 CAMINP(1),CAMOUT(1)
	DATA LOW16/'FFFF'X/
C++
C
C	VERIFY 24-BIT INPUT DATA BUFFER WITH 24-BIT OUTPUT DATA
C	BUFFER FOR THE LENGTH SPECIFIED BY THE TRANSFER COUNT.
C
C--
	DO TNDX=1,TC
	IF ((CAMINP(TNDX)-CAMOUT(TNDX) .AND. LOW16).NE. 0) THEN
		TYPE 1999,TNDX,CAMOUT(TNDX),CAMINP(TNDX)
		RETURN
	END IF
	END DO
1999	FORMAT(1X,'NDX=',I,' OUTPUT=',Z8,' INPUT=',Z8)
	RETURN
	END
