	program lamtest
	implicit integer(a-z)
c++
c
c	Note: Procedure names specified as arguments in 
c	procedure calls must be declared as external symbols.
c	Otherwise, the FORTRAN compiler will mistake the symbol
c	for a variable name in the calling procedure.
C
C--
	external lamast
c++
c
c	Define a CAMAC I/O status block buffer
c
c--
	integer*4 iosb(2)
c++
c
c	Use CHARACTER variables for logical module names.
c
c--
	character logmod*32,response*4
c++
c
c	We must enable AST delivery for the process when
c	using CAM$LAMAST, otherwise, AST delivery will be
c	blocked. This is a function of the design of VMS.
c
c--
	call sys$setast(%val(1))
c++
c
c	Prompt the user for the logical module name.
c
c--
1001	continue
	type 1999
1999	format(1x,'Enter logical module name ',$)
	accept 1998,loglen,logmod
1998	format(q,a)
	if (loglen.le.0) call exit
c++
c
c	LAM AST loop.
c	
c--
2001	continue
c++
c
c	Request a LAM AST for the specified CAMAC module via
c	the CAM$LAMASTW procedure call. Once the LAM AST has been
c	enabled for the specified module, control returns to the
c	calling program and normal execution may continue. When
c	the LAM from the module is recognized by the system, the
c	normal execution of the program is suspended and the LAM AST
c	procedure is called(i.e. the normal execution is interrupted
c	to service the LAM).
c	
c
c--
	status=cam$lamastw(logmod(1:loglen),lamast,%val(lam_efn),iosb)
c++
c
c	This represents the standard error checking procedure that
c	should be incorporated following a request to set a LAM AST.
c	Note that the IOSB returned from this call is not guaranteed
c	to look like a standard CAMAC I/O status block resulting from
c	one of the CAMAC I/O calls. A success status from the CAM$LAMAST
c	call indicates that the request was queued to the VAX internal CAMAC
c	software for processing. A success status from the I/O status block
c	indicates that the LAM AST was actually queued for the specified
c	module.
c
c--
	if (.not.status) then
		call lib$signal(%val(status))
		call cam$dassgn(key)
		go to 1001
	else
		if (.not.iosb(1)) then
			call lib$signal(%val(iosb(1)))
			call cam$dassgn(key)
			go to 1001
		end if
	end if
c++
c
c	Request that process hibernate. The LAM AST procedure will post
c	a wakeup request for the process when the LAM is generated.
c
c--
	call sys$hiber
c++
c
c	Repeat LAM test again?
c
c--
	type 1996
1996	format(1x,'LAM delivered successfully'/
	9	1x,'Go again? Y/N[Y] ',$)
	accept 1998,resplen,response
	if (resplen.eq.0 .or. 
	9	response(1:1).eq.'y' .or.
	9	response(1:1).eq.'Y') go to 2001
	go to 1001
	end
	integer function lamast(astprm)
	implicit integer(a-z)
c++
c
c	Simple LAM AST Service Procedure.
c
c	This LAM service procedure posts a wakeup request for
c	the process in response to the LAM. If the process is
c	currently hibernating, it will be awakened at the point 
c	where the hibernate request was made. If it is not presently
c	hibernating, the next hibernate request will be satisfied
c	immediately. Note that VMS does not maintain a count of 
c	pending wakeup requests for the process, i.e. "wakeup 
c	request pending" is simply a "LOGICAL" variable maintained 
c	by VMS for the process.
c
c--
	status=sys$wake(,)
	if (.not.status) then
		call lib$stop(%val(status))
	end if
	return
	end
