	program lamtest
	implicit integer(a-z)
c++
c
c	CAM$LAMWAIT returns a system status code as a function
c	value(just like all of the other CAMAC access procedures).
c	The code 'SS$_WASSET' is returned if the LAM wait is satisfied
c	within the specified time interval, 'SS$_WASCLR' is returned
c	if the LAM wait is not satisfied. Other system status codes may
c	be returned as indications of other failure conditions.
c
c--
	external ss$_wasset,ss$_wasclr
c++
c
c	Parameter definitions
c
c--
	parameter time_out=5			! time out value(sec)
c++
c
c	Use a CHARACTER variable for the logical module name.
c
c--
	character logmod*32,response*4
c++
c
c	Prompt for logical module name.
c
c--
1001	continue
	type 1999
1999	format(1x,'Enter logical module name ',$)
	accept 1998,loglen,logmod
1998	format(q,a)
	if (loglen.le.0) call exit
c++
c
c	Assign a key to the module for keyed reference.
c
c--
	status=cam$assign(logmod(1:loglen),key)
	if (.not.status) then
		call lib$stop(%val(status))
	end if
c++
c
c	LAM wait service loop.
c
c--
2001	continue
c++
c
c	Wait for a LAM from the specified CAMAC module.
c	The maximum amount of time to wait is specified by
c	the time out variable(TIME_OUT) in units of seconds.
c	In this case, TIME_OUT is defined as a PARAMETER.
c	It may also be defined as a variable.
c
c--
	status=cam$lamwait(%descr(key),time_out)
c++
c
c	This represents the proper method for checking for
c	success or failure status from the CAM$LAMWAIT procedure
c	call. The status returned from the procedure call indicates
c	(1) the LAM occurred within the specified amount of time,
c	indicated by a 'SS$_WASSET' value or (2) the LAM did not 
c	occur within the specified amount of time, indicated by a
c	'SS$_WASCLR' value or (3) the LAM wait request was not
c	executed due to an anomolous condition as indicated by the
c	return status.
c
c--
	if (.not.status) then
		call lib$signal(%val(status))
		call cam$dassgn(key)
		go to 1001
	end if
	if (status.eq.%loc(ss$_wasclr)) then
		type *,logmod,' LAM wait failed'
	else
		type *,logmod,' LAM wait successful'
	end if
c++
c
c	Repeat LAM wait test?
c
c--
	type 1996
1996	format(1x,'Go again? Y/N[Y] ',$)
	accept 1998,resplen,response
	if (resplen.le.0 .or. 
	9	response(1:1).eq.'y' .or.
	9	response(1:1).eq.'Y') go to 2001
	call cam$dassgn(key)
	go to 1001
	end
