	program l2551
	implicit integer(a-z)
c++
c
c	Define buffer parameters
c
c--
	parameter l2551_nchan=12		! number of LRS 2551 channels
c++
c
c	Execute list and reply list buffer parameters
c
c--
	parameter exe_datal=0			! execute list data length
	parameter exe_hdrlen=10			! execute list header length
	parameter exe_maxcmd=2			! max command frame count
	parameter exe_length=exe_hdrlen+
	9		exe_maxcmd*3+
	9		exe_datal		! execute list length(i*2 count)
	parameter rep_length=l2551_nchan*2
						! reply list length(i*2 count)
	parameter mem_l=24			! memory format=24 bit
c++
c
c	Define execute list buffer and reply list buffers
c
c--
	integer*2 exe_list(0:exe_length),
	9	rep_list(0:rep_length)
c++
c
c	Use CHARACTER variables for logical module names.
c
c--
	character*32 logmod

c++
c
c	Misc declarations
c
c--
	logical*4 cam$go

	type *,'LRS 2551 Module Exercisor'
c++
c
c	Prompt user for logical module name.
c
c--
	type 1999
1999	format(1x,'Enter logical module name ',$)
	accept 1998,loglen,logmod
1998	format(q,a)
	if (loglen.eq.0) call exit
c++
c
c	Initialize counter and then initialize
c	the LRS 2551 scaler module.
c
c--
	countl=0
	tc=12
	a=0
	f=9
	status=cam$pio(logmod(1:loglen),a,f)
	if (.not.cam$go(status,)) call exit
c++
c
c	Declare execute list buffer.
c	Note that the memory format(defined as a parameter) is explicitly
c	specified to override the CAMAC image block default value.
c
c--
	status=cam$dclst(exe_list,exe_length,mem_l)
	if (.not.status) then
		call lib$stop(%val(status))
	end if
c++
c
c*** Frame 1
c
c	Generate command frame to perform the channel increment
c	operation for the LRS 2551 module.
c
c--
	f=25
	status=cam$lpio(exe_list,logmod(1:loglen),a,f)
	if (.not.status) then 
		call lib$stop(%val(status))
	end if
c++
c
c*** Frame 2
c	Generate command frame to perform Q-Scan operation fo read
c	all 12 channels from the LRS 2551 module.
c
c--
	f=0
	status=cam$lqscan(exe_list,logmod(1:loglen),a,f,l2551_nchan)
	if (.not.status) then
		call lib$stop(%val(status))
	end if
c++
c
c	LRS 2551 test loop.
c
c--
1001	continue
	status=cam$executew(exe_list,rep_list,rep_length)
	if (.not.cam$go(status,)) then
		call exit
	end if
	countl=countl+1
	call verify(countl,rep_list,l2551_nchan)
	go to 1001
	end
	logical function cam$go(status,iosb)
	implicit integer(a-z)
	integer*4 iosb(*),liosb(2)
	logical*4 cam$error
	character response*4
c++
c
c	Assume failure by setting 'GO' false.
c
c--
	cam$go=.false.
c++
c
c	Test return status from CAMAC call. If failure indicated,
c	signal condition and prompt for action if control returns
c	after signal.
c
c--
	if (.not.status) then
		call lib$signal(%val(status))
		go to 1001
	end if
c++
c
c	If IOSB parameter specified as null, then sample the CAMAC
c	image block IOSB.
c--
	if (%loc(iosb).eq.0) then
		call cam$get_stat(liosb)
	else
		liosb(1)=iosb(1)
		liosb(2)=iosb(2)
	end if
c++
c
c	Test for any CAMAC errors. If so, then display nature of
c	the CAMAC error via CAM$SHOW_STAT and prompt for action.
c
c--
	if (cam$error(.true.,,liosb)) then
		call cam$show_stat(liosb)
		go to 1001
	end if
c++
c
c	Change assumed failure to success and return.
c
c--
	cam$go=.true.
	return
c++
c
c	Prompt for failure override response.
c
c--
1001	continue
	type 1999
1999	format(1x,'Override Failure? Y/[N] ',$)
	accept 1998,resp_len,response
1998	format(q,a)
	if (resp_len.eq.1 .and. 
	9	(response(1:1).eq.'y' .or.
	9	response(1:1).eq.'Y')) cam$go=.true.
	return
	end
	subroutine verify(countl,datal,nchan)
	implicit integer(a-z)
	integer*4 datal(*)
c++
c
c	Verify that all channels read from the LRS 2551 match
c	the expected count value(countl). Display channels that
c	do not match.
c
c--
	do i=1,nchan
	if (countl.ne.datal(i)) then
		type 1999,i,countl,datal(i)
	end if
1999	format(1x,'Mismatch: Chan=',i,2x,i,' Expected; ',i,' Read')
	end do
	return
	end
