c++
c
c facility
c	Oak Ridge National Laboratory
c	Fusion Energy Division
c	Tokamak Experimental Section
c
c abstract
c	This program is designed to exercise the Kinetic Systems 3291
c	dataway display module as a CAMAC system integrity test. This
c	test utilizes programmed, Stop mode and LAM service CAMAC
c	transactions to this module.
c author
c	E.T. Blair
c
c revision history
c	v01-000, E.T. Blair, 16-SEP-1982
c	Converted this program from the FED Perkin-Elmer 8/32 system to
c	run on the VAX.
c
c--
	program systst
	implicit integer(a-z)
c
c	External reference to generic control-c AST procedure
c
	external ctlc_ast
c
c	common for statistics accumulated by various tests
c
	common/sysblk/ pass,camtot,camerrs,
	9	rwerrs,aerrs,ferrs,lerrs

	logical*4 contus
	character ks_module*32
c
c	test names for prompts
c
	parameter tmax=4			! max test number
	parameter test_rw=1			! read/write test index
	parameter a_test=2			! subaddress test index
	parameter f_test=3			! function code test index
	parameter lam_test=4			! lam test index
	character test_name(tmax)*8
	data test_name/'TEST_RW','TEST_A','TEST_F','TEST_LAM'/
	logical test_enabl(tmax)
c
c	misc. data and parameters
c
	parameter ks_efn=0			! use event flag 0
	parameter mem_l=24			! 24-bit memory format
	character response*4
c
c	display startup header
c
	write(*,*) 'VAX CAMAC System Test'
c
c	select 24-bit memory format for all CAMAC calls.
c
	status=cam$cstate(%val(ks_efn),,,mem_l)
	if (.not.status) then
		call lib$stop(%val(status))
	end if
c
c	prompt for ks 3291 module name
c
50	continue
	write(*,1999)
1999	format(1x,'Enter module name of K.S. 3291;^z to exit ',$)
	read(*,1998,end=9999) ks_len,ks_module
1998	format(q,a)
	if (ks_len.le.0) then
		write(*,*) 'Invalid logical name length',ks_len
		go to 50
	end if
	call str$upcase(ks_module(1:ks_len),ks_module(1:ks_len))
	status=cam$assign(ks_module(1:ks_len),ks_key)
	if (.not.status) then
		call lib$stop(%val(status))
	end if
c
c     initialize for next test
c
	call ks_init(ks_key)
c
c	initialize common statistics for this test run
c
	contus=.false.
	pass=0
	camtot=0
	camerrs=0
	rwerrs=0
	aerrs=0
	ferrs=0
	lerrs=0
c
c	request tests to perform
c
	do i=1,tmax
	test_enabl(i)=.true.
	end do
	write(*,1987)
1987	format(1x,'Selective testing? Y/N[N] ',$)
	read(*,1998) resp_len,response
	if (resp_len.eq.1 .and. 
	9	(response(1:1).eq.'y' .or.
	9	response(1:1).eq.'Y')) then
		do i=1,tmax
		write(*,2999) test_name(i)
		read(*,1998) resp_len,response
		if (resp_len.eq.0 .or. response(1:1).eq.'n' .or.
	9		response(1:1).eq.'N') then
			test_enabl(i) = .false.
		end if
		end do
      end if
2999  format(1x,a,'? Y/N[N] ',$)
c
c     request rep count
c
	write(*,106)
106	format(1x,'Repetition count(i format;<=0 continuous) ',$)
	read(*,*) ks_passmax
	contus=.false.
	if (ks_passmax.le.0) then
		contus=.true.
		status=set_ctlc(ctlc_ast,contus)
		if (.not.status) then
			call lib$stop(%val(status))
		end if
		write(*,*) 'To stop test use ^C; to abort use ^Y'
	end if
	write(*,*) 'KS 3291 tests in progress; summary will follow.'
c
c	top of loop for sequence of ks 3291 tests
c	step 1. test dataway read/write lines
c	step 2. test dataway subaddress lines
c	step 4. test dataway lam for station n as well
c		lam grader/encoder and crate controller demand
c		generation.
c
1001  continue
	pass=pass+1
	if (.not.contus) then
		if (pass.gt.ks_passmax) then
			pass=pass-1
			call ks_reset(ks_key)
			call ks_summary(ks_module(1:ks_len))
			call cam$dassgn(ks_key)
			go to 50
		end if
	end if
c
c	test read-write lines
c
	if (test_enabl(test_rw)) then
		 call ks_test_rw(ks_key)
	end if
c	now test subaddress lines
c
	if (test_enabl(a_test)) then
		call ks_test_a(ks_key)
	end if
c
c	now test function code lines
c
	if (test_enabl(f_test)) then
		call ks_test_f(ks_key)
	end if
c
c	test lam line for station and lam service
c
	if (test_enabl(lam_test)) then
		call ks_test_lam(ks_key)
	end if
c
c	Delay for 1 second before next pass.
c
	status = wait(1,2)
	if (.not.status) then
		call lib$stop(%val(status))
	end if
	go to 1001
c
c	program exit
c
9999	continue
	call exit
	end
	logical function ks_error(status,iosb)
	implicit integer(a-z)
	integer*4 iosb(*)
	common/sysblk/ pass,camtot,camerrs,
	9	rwerrs,aerrs,ferrs,lerrs
	parameter exp_x=.true.		! expected x response=.true.
c
c	assume error
c
	ks_error=.true.
c
c	if call failure, signal status and stop image
c
	if (.not.status) then
		call lib$stop(%val(status))
	end if
c
c	if camac error, display iosb contents
c
	if (cam$error(exp_x,,iosb)) then
		call cam$show_stat(iosb)
		camerrs=camerrs+1
		return
	end if
c
c	change to indicate no error
c
	ks_error=.false.
	return
	end
	subroutine ks_show_data(ks_test,exp_data,act_data)
	implicit integer(a-z)
	character ks_test*(*)
c
c	display test name, expected result and actual result
c
	write(*,1999) ks_test,exp_data,act_data
1999	format(1x,a,' : ',z8,' expected; ',z8,' read')
	return
	end
c++
c
c***READ/WRITE TEST
c	Test crate dataway read/write lines. Each line is exercised
c	by first asserting that line, then by asserting all but that
c	line. The test verifies each pattern read from the KS 3291
c	against the pattern written to it.
c
c--
	subroutine ks_test_rw(ks_key)
	implicit integer(a-z)
	common/sysblk/ pass,camtot,camerrs,
	9	rwerrs,aerrs,ferrs,lerrs
c
c	define test name
c
	character ks_test*8/'TEST_RW'/


c
c	Test each read-write data line in the dataway, first with
c	the line asserted, then with all but that line asserted.
c
	do bit_pos=0,23
	iwdata=ishft(1,bit_pos)
	do rw_cycle=1,2
	camtot=camtot+1
	status=cam$stopw(%descr(ks_key),0,16,1,iwdata)
	if (.not.ks_error(status,)) then
		camtot=camtot+1
		status=cam$stopw(%descr(ks_key),0,0,1,irdata)
		if (.not.ks_error(status,)) then
			if (irdata.ne.iwdata) then
				rwerrs=rwerrs+1
				call ks_show_data(ks_test,iwdata,irdata)
			end if
		end if
	end if
	iwdata=iand(-iwdata-1,'ffffff'x)
	end do
	end do


      return
      end
c++
c
c***SUBADDRESS TEST
c	This test exercises the dataway subaddress lines. The test asserts
c	all legal subaddresses in sequence and verifies that they are properly
c	received by the KS 3291 module.
c
c--
	subroutine ks_test_a(ks_key)
	implicit integer(a-z)
	common/sysblk/ pass,camtot,camerrs,
	9	rwerrs,aerrs,ferrs,lerrs
c
c	define test name
c
	character ks_test*8/'TEST_A'/


	do a_loop=0,15
	camtot=camtot+1
	status=cam$piow(%descr(ks_key),a_loop,8)
	if (.not.ks_error(status,)) then
		camtot=camtot+1
		status=cam$piow(%descr(ks_key),1,0,ctl_reg)
		if (.not.ks_error(status,)) then
			a_value=iand(ishft(ctl_reg,-6),'f'x)
			if (a_value.ne.a_loop) then
				aerrs=aerrs+1
				call ks_show_data(ks_test,a_loop,a_value)
			end if
		end if
	end if
	end do


	return
	end
c++
c
c***FUNCTION CODE TEST
c	This test exercises the dataway function code lines. The test asserts
c	all legal function codes in sequence and then verifies that they are
c	properly received by the module.
c
c--
	subroutine ks_test_f(ks_key)
	implicit integer(a-z)
	common/sysblk/ pass,camtot,camerrs,
	9	rwerrs,aerrs,ferrs,lerrs
c
c	define test name
c
	character ks_test*8/'TEST_F'/

	do f_loop=0,31
	camtot=camtot+1
	dumy=0
	status=cam$piow(%descr(ks_key),12,f_loop,dumy)
	if (.not.ks_error(status,)) then
		camtot=camtot+1
		status=cam$piow(%descr(ks_key),1,0,ctl_reg)
		if (.not.ks_error(status,)) then
			f_value=iand(ctl_reg,'1f'x)
			if (f_value.ne.f_loop) then
				ferrs=ferrs+1
				call ks_show_data(ks_test,f_loop,f_value)
			end if
		end if
	end if
	end do

	return
	end
c++
c
c***LAM TEST
c	This test verifies that the LAM line for the station where the KS
c	3291 is sitting can be asserted and recognized by the crate controller
c	and that a demand can be generated by that crate controller and
c	subsequently recognized and delivered as a LAM AST by the CAMAC ACP
c	to the process executing this image.
c
c--
	subroutine ks_test_lam(ks_key)
	implicit integer(a-z)
	common/sysblk/ pass,camtot,camerrs,
	9	rwerrs,aerrs,ferrs,lerrs
c
c	define test name
c
	character ks_test*8/'TEST_LAM'/

	parameter lam_timout=2		! lam wait time out
c
c	set lam
c
	camtot=camtot+1
	status=cam$piow(%descr(ks_key),0,14)
	if (ks_error(status,)) then
		write(*,*) ks_test,': SET LAM'
		return
	end if
c
c	test to be sure lam is set
c
	camtot=camtot+1
	status=cam$piow(%descr(ks_key),15,8)
	if (ks_error(status,)) then
		write(*,*) ks_test,': PRE-LAM TEST'
		return
	end if
	if (.not.cam$q()) then
		lerrs=lerrs+1
		write(*,*) ks_test,': LAM not asserted'
		return
	end if
c
c	now execute a lam wait to check grader
c
	status=cam$lamwait(%descr(ks_key),lam_timout)
	if (.not.status) then
		call lib$stop(%val(status))
	end if
	if (status.eq.%loc(ss$_wasclr)) then
		lerrs=lerrs+1
		write(*,*) ks_test,': LAM wait failure'
		return
	end if
c
c	clear lam
c
	camtot=camtot+1
	status=cam$piow(%descr(ks_key),0,10)
	if (ks_error(status,)) then
		write(*,*) ks_test,': CLEAR LAM'
	return
	end if
c
c	check to be sure that lam is actually clear
c
	camtot=camtot+1
	status=cam$piow(%descr(ks_key),15,8)
	if (ks_error(status,)) then
		write(*,*) ks_test,': POST-LAM TEST'
		return
	end if
	if (cam$q()) then
		lerrs=lerrs+1
		write(*,*) ks_test,': LAM not reset'
		return
	end if


      return
      end
c++
c
c***MODULE_INITIALIZATION
c	This procedure initializes the KS 3291 module and readies it
c	for subsequent testing by the program. If any step in the
c	initialization process fails, the user is prompted for an
c	action response to either override(ignore) the failure or
c	abort.
c--
	subroutine ks_init(ks_key)
	implicit integer(a-z)
	parameter mod_sel=1
	parameter clear=16
c
c	define test name
c
	character ks_test*8/'MOD_INIT'/
	character response*4
c
c	read module id and verify
c
	status=cam$piow(%descr(ks_key),15,1,mod_id)
	if (ks_error(status,)) then
		write(*,*) ks_test,': MODULE ID'
		go to 1001
	end if
	if (mod_id.ne.3291) then
		write(*,*) 'Module ID failure: value=',mod_id
		go to 1001
	end if
c
c	output control register(clear)
c
	status=cam$piow(%descr(ks_key),0,17,clear)
	if (ks_error(status,)) then
		write(*,*) ks_test,': MODULE CLEAR'
		go to 1001
	end if
c
c	output control register( n.and.s1)
c
	status=cam$piow(%descr(ks_key),0,17,mod_sel)
	if (ks_error(status,)) then
		write(*,*) ks_test,': MODE SELECT'
		go to 1001
	end if
c
c	read control register and verify mode
c
	status=cam$piow(%descr(ks_key),0,1,ctl_reg)
	if (ks_error(status,)) then
		write(*,*) ks_test,': CTL REG'
		go to 1001
	end if
	if (ctl_reg.ne.mod_sel) then
		write(*,*) 'Mode select failure: Ctl_reg=',ctl_reg
		go to 1001
	end if
	return
c
c	Module initialization failure exit
c
1001	continue
	write(*,1999)
1999	format(1x,'Override module initialization failure? Y/N[N] ',$)
	accept 1998,resp_len,response
1998	format(q,a)
	if (resp_len.le.0 .or.
	9	response(1:1).eq.'N' .or.
	9	response(1:1).eq.'n') then
		call exit
	end if
	return
	end
	subroutine ks_summary(ks_module)
	implicit integer(a-z)
	character ks_module*(*)
	common/sysblk/ pass,camtot,camerrs,
	9	rwerrs,aerrs,ferrs,lerrs
	real*4 pcnt
c
c	type summary of test statistics using present values
c
	write(*,1999) ks_module,pass
1999	format(1x,'Summary for ',a,' Current pass=',i)
	pcnt=100.0*float(camerrs)/float(camtot)
	write(*,1998) camtot,camerrs,pcnt
1998	format(1x,'CAMAC transmission statistics'/
	9	1x,'Requests=',i,' ;Errors=',i,' ; ',
	9	f4.1,' % failures')
	write(*,1997) rwerrs,aerrs,ferrs,lerrs
1997	format(1x,'Data Integrity Failures'/
	9	1x,'Read/Write test: ',i/
	9	1x,'Subaddress test: ',i/
	9	1x,'Function code test: ',i/
	9	1x,'LAM test: ',i)
	return
	end
	subroutine ks_reset(ks_key)
	implicit integer(a-z)
	parameter clear=16
c
c	define test name
c
	character ks_test*8/'RESET'/
c
c	reset ks3291 control register for dataway display(s1 mode)
c
	status=cam$piow(%descr(ks_key),0,17,clear)
	if (ks_error(status,)) then
		write(*,*) ks_test,': MODULE RESET'
		call exit
	end if
	return
	end
	integer function wait(delay,units)
	implicit integer(a-z)
c+++
c
c	This subroutine implements the standard FORTRAN WAIT call.
c
c	Parameters:
c	delay(i*4)-number of units to delay execution of the calling
c		program,
c	units(i*4)-code specifying units of the delay parameter:
c		1 - milliseconds,
c		2 - seconds,
c		3 - minutes.
c
c---

	external ss$_badparam
	real*4 msec_to_tu,sec_to_tu,min_to_tu
	parameter (msec_to_tu=1.0e4)		! tu/msec factor
	parameter (sec_to_tu=1.0e7)		! tu/second factor
	parameter (min_to_tu=60.0*sec_to_tu)	! tu/minute factor
	parameter (max_tu='7fffffff'x)		! max delay(in tu's)
	parameter (min_max=max_tu/min_to_tu)	! max delay(minutes)
	parameter (sec_max=max_tu/sec_to_tu)	! max delay(seconds)
	parameter (msec_max=max_tu/msec_to_tu)	! max delay(msec)

	real*4 tu_fact(3)
	data tu_fact/msec_to_tu,sec_to_tu,min_to_tu/
	integer*4 delay_max(3)
	data delay_max/msec_max,sec_max,min_max/
	integer*4 sch_wak_delt(2)
	
c
c	verify units argument
c
	if (units.le.0 .or. units.gt.3) then
		wait = %loc(ss$_badparam)
		return
	end if
c
c	verify delay as a function of the units value.
c
	if (delay.lt.0 .or. delay.gt.delay_max(units)) then
		wait = %loc(ss$_badparam)
		return
	end if
c
c	schedule wakeup for process using specified delay and units values
c	to compute the delay time in vax timer units(1 tu = 100 nanosec.)
c
	sch_wak_delt(2)=-1
	sch_wak_delt(1)=-delay*tu_fact(units)
	wait=sys$schdwk(,,sch_wak_delt,)
	if (.not.wait) then
		return
	end if
c
c	hibernate until awakened
c
	wait=sys$hiber(,)
	return
	end
