	PROGRAM PSI_RECEIVE
C
C 			COPYRIGHT (c) 1980 BY
C 	DIGITAL EQUIPMENT CORPORATION, MAYNARD, MASSACHUSETTS 01754
C
C THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY BE USED AND  COPIED
C ONLY  IN  ACCORDANCE  WITH  THE  TERMS  OF  SUCH  LICENSE AND WITH THE
C INCLUSION OF THE ABOVE COPYRIGHT NOTICE.  THIS SOFTWARE OR  ANY  OTHER
C COPIES  THEREOF MAY NOT BE PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY
C OTHER PERSON.  NO TITLE TO AND OWNERSHIP OF  THE  SOFTWARE  IS  HEREBY
C TRANSFERRED.
C
C THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE  WITHOUT  NOTICE
C AND  SHOULD  NOT  BE  CONSTRUED  AS  A COMMITMENT BY DIGITAL EQUIPMENT
C CORPORATION.
C
C DIGITAL ASSUMES NO RESPONSIBILITY FOR THE USE OR  RELIABILITY  OF  ITS
C SOFTWARE ON EQUIPMENT WHICH IS NOT SUPPLIED BY DIGITAL.
C

C++
C
C Facility:
C
C	VAX-11 PSI/PSS Example Program.
C
C Abstract:
C
C	This program is one of a pair of demonstration programs which
C	will transfer data entered at the terminal from one VAX-11 to
C	another over a Packet Switched Network. This program should be
C	defined as an object to be run for an incoming call.
C
C Environment:
C
C	Native mode VAX processor, User mode.
C
C Author:
C
C	Stephen Peters,		01-Apr-1981
C
C
C--
C+
C External References:
C-
	IMPLICIT INTEGER*4 S
	EXTERNAL IO$_ACCESS, IO$_DEACCESS, IO$M_ACCEPT
	EXTERNAL IO$_READVBLK, IO$_WRITEVBLK
C+
C Literal Definitions:
C-
	INTEGER*2 MBXBUFSIZ, RCV_LEN
	CHARACTER* (*)  PSI_DEV, MBX
	PARAMETER  (PSI_DEV = '_NWA0:') 
	PARAMETER  (MBX = 'SYS$NET') 
	PARAMETER  (MBXBUFSIZ = 200) 
	PARAMETER  (RCV_LEN = 200) 
C+
C Local Variables:
C-
	INTEGER*4 ACCEPT_NCB (2), FUNC
	INTEGER*2 IOSB (4), PSI_CHAN, MBX_CHAN
	LOGICAL*1 MBXBUF (MBXBUFSIZ), RCV_BUF (RCV_LEN) 
C+
C Open SYS$OUTPUT to write out message.
C-
	OPEN (UNIT = 1, FILE = 'SYS$OUTPUT', STATUS = 'NEW') 
C+
C Assign mailbox for network.
C-
	type *,' assigning mailbox '
	I = SYS$ASSIGN (MBX, MBX_CHAN,,) 
	type *,' mailbox assigned ',mbx
	IF (.NOT.I) GOTO 99
C+
C Assign a channel for PSI.
C-
	type *,' assigning channel '
	I = SYS$ASSIGN (PSI_DEV, PSI_CHAN,, MBX) 
	type *,' channel assigned ',psi_chan
	IF (.NOT.I) GOTO 99
C+
C Read the mailbox for connects.
C-
	I = SYS$QIOW (%VAL (0), %VAL (MBX_CHAN), IO$_READVBLK, IOSB,,, 
	1 MBXBUF, %VAL (MBXBUFSIZ),,,,) 
	IF (.NOT.I) GOTO 99
	IF (.NOT.IOSB (1)) GOTO 98
C+
C Accept the connection.
C-
	ACCEPT_NCB (1)  = MBXBUF (21) 
	ACCEPT_NCB (2)  = %LOC (MBXBUF (22)) 
	FUNC = %LOC (IO$_ACCESS) .OR.%LOC (IO$M_ACCEPT) 
	I = SYS$QIOW (%VAL (0), %VAL (PSI_CHAN), %VAL (FUNC), IOSB,,, 
	1 %VAL (0), ACCEPT_NCB,,,,) 
	IF (.NOT.I) GOTO 99
	IF (.NOT.IOSB (1)) GOTO 98
C+
C Loop to receive messages from PSI_SEND. If an end of file message
C is received  (first byte contains 26 - control-Z),  clear the call.
C-
10	I = SYS$QIOW (%VAL (0), %VAL (PSI_CHAN), IO$_READVBLK, IOSB,,, 
	1 RCV_BUF, %VAL (RCV_LEN),,,,) 
	IF (.NOT.I) GOTO 99
	IF (.NOT.IOSB (1)) GOTO 98
C+
C If message is ^Z then exit else output message.
C-
	IF (RCV_BUF (1) .EQ.26) GOTO 20
	WRITE (1, 100)  (RCV_BUF (J), J = 1, IOSB (2)) 
100	FORMAT (' ', 80A1) 
	GOTO 10
C+
C End of file - close output file.
C-
20	CLOSE (UNIT = 1) 
C+
C Clear the call.
C-
	I = SYS$QIOW (%VAL (0), %VAL (PSI_CHAN), IO$_DEACCESS, IOSB,,, 
	1 ,,,,,) 
	IF (.NOT.I) GOTO 99
	IF (.NOT.IOSB (1)) GOTO 98
C+
C Deassign the network device channel.
C-
	I = SYS$DASSGN (%VAL (PSI_CHAN)) 
	IF (.NOT.I) GOTO 99
C+
C Deassign mailbox channel.
C-
	I = SYS$DASSGN (%VAL (MBX_CHAN)) 
	IF (.NOT.I) GOTO 99
C+
C Exit with success code.
C-
	CALL SYS$EXIT (%VAL (1)) 
C+
C Exit with error status.
C-
98	I = IOSB (1) 
99	CALL SYS$EXIT (%VAL (I)) 
	END
