!
!			  COPYRIGHT (c) 1982 BY
!	      MOSTEK CORPORATION, CARROLLTON TX
!
! This software is furnished under a license and may be used and  copied
! only  in  accordance  with  the  terms  of  such  license and with the
! inclusion of the above copyright notice.  This software or  any  other
! copies  thereof may not be provided or otherwise made available to any
! other person.  No title to and ownership of  the  software  is  hereby
! transferred.
!
! The information in this software is subject to change  without  notice
! and  should  not  be  construed  as  a commitment by MOSTEK
! CORPORATION.
!
! MOSTEK assumes no responsibility for the use or  reliability  of  its
! software on equipment which is not supplied by MOSTEK.
!

!++
! FACILITY:
!   MOSTEK CORPORATION
!
! ABSTRACT: Block data for common elements for REPLAY and PLOT
!   
!
! ENVIRONMENT: VAX/VMS unpriv
!   
!
! AUTHOR: Gary Smith, CREATION DATE: 12/10/1982
!
! MODIFIED BY:
!
!--
!
! TABLE OF CONTENTS:
!
!
! INCLUDE FILES: mousesubs.for
!                defrec.for
!                statsubs.for
!
!
! MACROS: none
!
!
! EQUATED SYMBOLS: see mousesubs.for
!                      defrec.for
!
!
! EXTERNAL REFERENCES: none
!

!++
! FUNCTIONAL DESCRIPTION: Build up a common for use by both PLOT and REPLAY
!
!
!
! FORMAL PARAMETERS: none
!
!
!
! IMPLICIT INPUTS: none
!
!
!
! IMPLICIT OUTPUTS: none
!
!
!
! ROUTINE VALUE and
! COMPLETION CODES: none
!
!
!
! SIDE EFFECTS: none
!
!
!
!--

          BLOCK DATA CATEGORY_DATA

          include 'mousesubs.for'
          include 'defrec.for'
          include 'statsubs.for'
          include 'catdef.for'

!++
! define the category tables
!--

          integer cat_state(max_cat,max_ent), cat_len(rec_size)

          character * 63 cat_title(rec_size)
!++
! set up for cpu 
!--
          data cat_state( 1,  1 ) / kernel /
          data cat_state( 1,  2 ) / super  /
          data cat_state( 1,  3 ) / exec   /
          data cat_state( 1,  4 ) / user   /
          data cat_state( 1,  5 ) / int    /
          data cat_state( 1,  6 ) / compat /
          data cat_state( 1,  7 ) / idle   /
          data cat_state( 1,  8 ) / bjobcnt /
          data cat_state( 1,  9 ) / ijobcnt /

!++
! set up for FCP 
!--

          data cat_state( 2,  1 ) / c_call   /
          data cat_state( 2,  2 ) / c_cache  /
          data cat_state( 2,  3 ) / c_cpu    /
          data cat_state( 2,  4 ) / c_read   /
          data cat_state( 2,  5 ) / c_write  /

!++
! set up for miscellaneous stats
!--

          data cat_state( 3,  1 ) / c_dirio    /
          data cat_state( 3,  2 ) / c_bufio    /
          data cat_state( 3,  3 ) / c_lognam   /
          data cat_state( 3,  4 ) / c_mbreads  /
          data cat_state( 3,  5 ) / c_mbwrites /
          data cat_state( 3,  6 ) / c_turn     /
          data cat_state( 3,  7 ) / c_split    /
          data cat_state( 3,  8 ) / c_hit      /
          data cat_state( 3,  9 ) / c_opens    /
          data cat_state( 3, 10 ) / c_open     /
          data cat_state( 3, 11 ) / c_dirhit   /
          data cat_state( 3, 12 ) / c_dirmiss  /
          data cat_state( 3, 13 ) / c_exthit   /
          data cat_state( 3, 14 ) / c_extmiss  /
          data cat_state( 3, 15 ) / c_fidhit   /
          data cat_state( 3, 16 ) / c_fidmiss  /
          data cat_state( 3, 17 ) / c_quohit   /
          data cat_state( 3, 18 ) / c_quomiss  /

!++
! set up for memory stats
!--

          data cat_state( 4,  1 ) / c_freecnt /
          data cat_state( 4,  2 ) / c_mfycnt  /

!++
! set up for page faults
!--
          data cat_state( 5,  1 ) / c_dzroflts /
          data cat_state( 5,  2 ) / c_faults   /
          data cat_state( 5,  3 ) / c_preadio  /
          data cat_state( 5,  4 ) / c_pwritio  /
          data cat_state( 5,  5 ) / c_preads   /
          data cat_state( 5,  6 ) / c_pwrites  /
          data cat_state( 5,  7 ) / c_rdflts   /

!++
! set up for scheduler states
!--
          data cat_state( 6,  1 ) / c_colpg /
          data cat_state( 6,  2 ) / c_mwait /
          data cat_state( 6,  3 ) / c_cef   /
          data cat_state( 6,  4 ) / c_pfw   /
          data cat_state( 6,  5 ) / c_lef   /
          data cat_state( 6,  6 ) / c_lefo  /
          data cat_state( 6,  7 ) / c_hib   /
          data cat_state( 6,  8 ) / c_hibo  /
          data cat_state( 6,  9 ) / c_susp  /
          data cat_state( 6, 10 ) / c_suspo /
          data cat_state( 6, 11 ) / c_fpg   /
          data cat_state( 6, 12 ) / c_com   /
          data cat_state( 6, 13 ) / c_como  /
          data cat_state( 6, 14 ) / c_cur   /


!++
! set up for swapping category
!--

          data cat_state( 7,  1 ) / c_ispagcnt /
          data cat_state( 7,  2 ) / c_iswpcnt  /
          data cat_state( 7,  3 ) / c_proccnt  /
          data cat_state( 7,  4 ) / c_oswpcnt  /
          data cat_state( 7,  5 ) / c_hoswpcnt /
          data cat_state( 7,  6 ) / c_hiswpcnt /

!++
! set up for the repsonse
!++

          data cat_state( 11, 1 ) / c_response /

!++
! set up for the DECnet category
!--
          data cat_state( 9,  1 ) / c_arrlocpk /
          data cat_state( 9,  2 ) / c_arrtrapk /
          data cat_state( 9,  3 ) / c_deplocpk /
          data cat_state( 9,  4 ) / c_rcvbuffl /
          data cat_state( 9,  5 ) / c_trcnglos /


!++
! set up for ENQ/DEQ category
!--

          data cat_state( 10, 1 ) / c_enqnew   /
          data cat_state( 10, 2 ) / c_enqwait  /
          data cat_state( 10, 3 ) / c_deq      /
          data cat_state( 10, 4 ) / c_dlckfnd  /
          data cat_state( 10, 5 ) / c_dlcksrch /
          data cat_state( 10, 6 ) / c_enqcvt   /
          data cat_state( 10, 7 ) / c_enqnotqd /

!++
! set up for non-paged pool
!--

          data cat_state( 12, 1 ) / c_irpcnt    /
          data cat_state( 12, 2 ) / c_holecnt   /
          data cat_state( 12, 3 ) / c_bighole   /
          data cat_state( 12, 4 ) / c_smallhole /
          data cat_state( 12, 5 ) / c_smallcnt  /
          data cat_state( 12, 6 ) / c_holesum   /
          data cat_state( 12, 7 ) / c_lrpcnt    /
          data cat_state( 12, 8 ) / c_srpcnt    /

!++
! Titles for the CPU category
!--

          data cat_title(kernel)  / '% Kernel Mode'         /
          data cat_title(super)   / '% Supervisor Mode'     /
          data cat_title(exec)    / '% Executive Mode'      /
          data cat_title(user)    / '% User Mode'           /
          data cat_title(int)     / '% Interrupt Stack'     /
          data cat_title(compat)  / '% Compatability Mode'  /
          data cat_title(idle)    / '% Idle'                /
          data cat_title(bjobcnt) / 'Batch Users'           /
          data cat_title(ijobcnt) / 'Interactive Users'     /

!++
! Titles for the FCP category
!--
          data cat_title(c_call)  / 'FCP Calls'      /
          data cat_title(c_cache) / 'FCP Cache Hits' /
          data cat_title(c_cpu)   / 'FCP Cpu Used'   /
          data cat_title(c_read)  / 'FCP Reads'      /
          data cat_title(c_write) / 'FCP Writes'     /

!++
! Titles for miscellaneous categories
!--
          data cat_title(c_dirio)    / 'Direct I/O'                /
          data cat_title(c_bufio)    / 'Buffered I/O'              /
          data cat_title(c_lognam)   / 'Log Name Trans'            /
          data cat_title(c_mbreads)  / 'Mail Box Reads'            /
          data cat_title(c_mbwrites) / 'Mail Box Writes'           /
          data cat_title(c_turn)     / 'Window Turns'              /
          data cat_title(c_split)    / 'Split I/O Operations'      /
          data cat_title(c_hit)      / 'I/O w/o Window Turns'      /
          data cat_title(c_opens)    / 'File Opens'                /
          data cat_title(c_open)     / 'Open Files'                /
          data cat_title(c_dirhit)   / 'Directory Hits'            /
          data cat_title(c_dirmiss)  / 'Directory Misses'          /
          data cat_title(c_exthit)   / 'Extent Hits'               /
          data cat_title(c_extmiss)  / 'Extent Misses'             /
          data cat_title(c_fidhit)   / 'File ID Hits'              /
          data cat_title(c_fidmiss)  / 'File ID Misses'            /
          data cat_title(c_quohit)   / 'Quota Hits'                /
          data cat_title(c_quomiss)  / 'Quota Misses'              /

!++
! Titles for memory category
!--

          data cat_title(c_freecnt) / 'Free Page Count'     /
          data cat_title(c_mfycnt ) / 'Modified Page Count' /

!++
! Titles for page fault category
!--
          data cat_title(c_dzroflts) / 'Demand Zero Faults' /
          data cat_title(c_faults)   / 'Page Faults'        /
          data cat_title(c_preadio)  / 'Page Read I/O'      /
          data cat_title(c_pwritio)  / 'Page Write I/O'     /
          data cat_title(c_preads)   / 'Page Reads'         /
          data cat_title(c_pwrites)  / 'Page Writes'        /
          data cat_title(c_rdflts)   / 'Page Read Faults'   /

!++
! Titles for scheduler states
!--

          data cat_title(c_colpg) / 'Collided Page Wait '             /
          data cat_title(c_mwait) / 'Miscellaneous Wait'              /
          data cat_title(c_cef)   / 'Common Event Flag Wait'          /
          data cat_title(c_pfw)   / 'Page Fault Wait'                 /
          data cat_title(c_lef)   / 'Local Event Flag Wait'           /
          data cat_title(c_lefo)  / 'Local Event Flag Outswapped'     /
          data cat_title(c_hib)   / 'Hibernating'                     /
          data cat_title(c_hibo)  / 'Hibernating Outswapped'          /
          data cat_title(c_susp)  / 'Suspended'                       /
          data cat_title(c_suspo) / 'Suspended Outswapped'            /
          data cat_title(c_fpg)   / 'Free Page Wait'                  /
          data cat_title(c_com)   / 'Compute'                         /
          data cat_title(c_como)  / 'Compute Outswapped'              /
          data cat_title(c_cur)   / 'Current'                         /

!++
! Titles for swap category
!--
          data cat_title(c_ispagcnt) / 'In Swap Page Count'          /
          data cat_title(c_iswpcnt)  / 'In Swap Count'               /
          data cat_title(c_proccnt)  / 'Processes Needing Swap File' /
          data cat_title(c_oswpcnt)  / 'Out Swap Count'              /
          data cat_title(c_hoswpcnt) / 'Header Outswaps'             /
          data cat_title(c_hiswpcnt) / 'Header Inswaps'              /

!++
! Y title for the "system response"
!--
          data cat_title(c_response) / 'System Response' /

!++
! Y title for the DECnet category
!--
          data cat_title(c_arrlocpk) / 'Arriving Local Packets'    /
          data cat_title(c_arrtrapk) / 'Arriving Transmit Packets' /
          data cat_title(c_deplocpk) / 'Departing Local Packets'   /
          data cat_title(c_rcvbuffl) / 'Receive Buffer Fail'       /
          data cat_title(c_trcnglos) / 'Transmit Congestion Loss'  /

!++
! Titles for the ENQ/DEQ category
!--
          data cat_title(c_enqnew)   / 'New ENQ''s'         /
          data cat_title(c_enqwait)  / 'ENQ Wait'           /
          data cat_title(c_deq)      / 'DEQ''s'             /
          data cat_title(c_dlckfnd)  / 'Dead Lock Finds'    /
          data cat_title(c_dlcksrch) / 'Dead Lock Searches' /
          data cat_title(c_enqcvt)   / 'ENQ''s Converted'   /
          data cat_title(c_enqnotqd) / 'ENQ''s Not Queued'  /

!++
! Titles for the non-paged pool
!--

          data cat_title(c_irpcnt)    / 'IRPs Left'                 /
          data cat_title(c_lrpcnt)    / 'LRPs Left'                 /
          data cat_title(c_srpcnt)    / 'SRPs Left'                 /
          data cat_title(c_holecnt)   / 'Holes in Pool'             /
          data cat_title(c_bighole)   / 'Largest Block'             /
          data cat_title(c_smallhole) / 'Smallest Block'            /
          data cat_title(c_smallcnt)  / '32 Byte or Smaller Blocks' /
          data cat_title(c_holesum)   / 'Total Space Left'          /

!++
! create the common
!--

          common / category / cat_state, cat_title, cat_len

          end
