!
!			  COPYRIGHT (c) 1982 BY
!	      MOSTEK CORPORATION, CARROLLTON TX
!
! This software is furnished under a license and may be used and  copied
! only  in  accordance  with  the  terms  of  such  license and with the
! inclusion of the above copyright notice.  This software or  any  other
! copies  thereof may not be provided or otherwise made available to any
! other person.  No title to and ownership of  the  software  is  hereby
! transferred.
!
! The information in this software is subject to change  without  notice
! and  should  not  be  construed  as  a commitment by MOSTEK
! CORPORATION.
!
! MOSTEK assumes no responsibility for the use or  reliability  of  its
! software on equipment which is not supplied by MOSTEK.
!

!++
! FACILITY:
!   MOSTEK CORPORATION
!
! ABSTRACT: COMPRESS squeezes a pcb (parse control block) into a string
!   
!
! ENVIRONMENT: VAX/VMS unpriv
!   
!
! AUTHOR: Gary Smith, CREATION DATE: 4/04/83
!
! MODIFIED BY:
!
!--
!
! TABLE OF CONTENTS:
!
!
! INCLUDE FILES: none
!
!
! MACROS: none
!
!
! EQUATED SYMBOLS: none
!
!
! EXTERNAL REFERENCES: none
!

!++
! FUNCTIONAL DESCRIPTION: The PCB as created by the parser is a mixture
!                         of numbers and characters masquerading as numbers.
!                         COMPRESS turns these into bona fide character 
!                         strings.
!
!
!
! FORMAL PARAMETERS: PCB -> the parse control block that starts the string
!                           descriptor
!
!
!
! IMPLICIT INPUTS: none
!
!
!
! IMPLICIT OUTPUTS: none
!
!
!
! ROUTINE VALUE and
! COMPLETION CODES: The compressed string
!
!
!
! SIDE EFFECTS: none to date
!
!
!
!--
          CHARACTER * 132 FUNCTION COMPRESS( PCB )

          character * 132 local_string

          byte r_local_string(132)

          integer pcb(1)

          equivalence( local_string, r_local_string(1) )

!++
! clear out any trash floating around
!--

          local_string = ' '
          compress = ' '

!++
! copy the characters into the local string
!--

          do i = 1, pcb(1)
             r_local_string(i) = pcb(1+i)
          end do
    
!++
! leave with the compressed string
!--

          compress = local_string
          return
          end
          
