!
!			  COPYRIGHT (c) 1982 BY
!	      MOSTEK CORPORATION, CARROLLTON TX
!
! This software is furnished under a license and may be used and  copied
! only  in  accordance  with  the  terms  of  such  license and with the
! inclusion of the above copyright notice.  This software or  any  other
! copies  thereof may not be provided or otherwise made available to any
! other person.  No title to and ownership of  the  software  is  hereby
! transferred.
!
! The information in this software is subject to change  without  notice
! and  should  not  be  construed  as  a commitment by MOSTEK
! CORPORATION.
!
! MOSTEK assumes no responsibility for the use or  reliability  of  its
! software on equipment which is not supplied by MOSTEK.
!

!++
! FACILITY:
!   MOSTEK CORPORATION
!
! ABSTRACT:
!   This subroutine approximates the behavior of the break-key facility
!   found on CP-6 systems
!
! ENVIRONMENT:
!   VAX-11 VMS
!
! AUTHOR: Gary Smith, CREATION DATE: 6/24/82
!
! MODIFIED BY:
!
!--
!
! TABLE OF CONTENTS:
!
!
! INCLUDE FILES:
!   none
!
! MACROS:
!   none
!
! EQUATED SYMBOLS:
!   none
!
! EXTERNAL REFERENCES:
!   SYS$ASSIGN, LIB$INIT_TIMER, SYS$QIO, LIB$SHOW_TIMER, LIB$SHOW_VM, TRNLOG
!   CNCINIT, SETRAP

!++
! FUNCTIONAL DESCRIPTION:
!   CONTROLT is called with no arguemnts. It sets up the necessary information
!   to create an AST to field the control c when it pressed form the key-
!   board.
!
!
! FORMAL PARAMETERS:
!   none
!
!
! IMPLICIT INPUTS:
!   none
!
!
! IMPLICIT OUTPUTS:
!   none
!
!
! ROUTINE VALUE and
! COMPLETION CODES:
!   none
!
!
! SIDE EFFECTS:
!   none to date
!
!
!--
	subroutine controlt
	call cncinit
	call setrap
	return
	end
!
	subroutine cncinit
	character*64 devnam
	integer devlen,dvperm
	integer*4 chan,func
	external brkon
	call trnlog('TT',devnam,devlen,dvperm)
	call SYS$ASSIGN(devnam(1:devlen),%ref(chan),,)
	call LIB$INIT_TIMER()
	return
!
	entry setrap
	data func /'00000123'X/
	call SYS$QIO(,%val(chan),%val(func),,,,brkon,,,,,)
	return
	end
!
	subroutine brkon
	call setrap
	call LIB$SHOW_TIMER()
	call LIB$SHOW_VM()
	return
	end
