!
!			  COPYRIGHT (c) 1982 BY
!	      MOSTEK CORPORATION, CARROLLTON TX
!
! This software is furnished under a license and may be used and  copied
! only  in  accordance  with  the  terms  of  such  license and with the
! inclusion of the above copyright notice.  This software or  any  other
! copies  thereof may not be provided or otherwise made available to any
! other person.  No title to and ownership of  the  software  is  hereby
! transferred.
!
! The information in this software is subject to change  without  notice
! and  should  not  be  construed  as  a commitment by MOSTEK
! CORPORATION.
!
! MOSTEK assumes no responsibility for the use or  reliability  of  its
! software on equipment which is not supplied by MOSTEK.
!

!++
! FACILITY:
!   MOSTEK CORPORATION
!
! ABSTRACT: Determines the difference in seconds between two times
!   
!
! ENVIRONMENT: VAX VMS unpriv
!   
!
! AUTHOR: Gary Smith, CREATION DATE: 9/8/1982
!
! MODIFIED BY:
!
!--
!
! TABLE OF CONTENTS:
!
!
! INCLUDE FILES: none
!
!
! MACROS: none
!
!
! EQUATED SYMBOLS: none
!
!
! EXTERNAL REFERENCES: LIB$SUBX, LIB$EDIV
!

!++
! FUNCTIONAL DESCRIPTION: Two strings that are the character representation
!                         of the time of day converted to binary
!                         equivalents and the delta time of the two is 
!                         taken.
!
!
!
! FORMAL PARAMETERS: start_time -> the starting time
!                    end_time   -> the ending time
!
!
! IMPLICIT INPUTS: none
!
!
!
! IMPLICIT OUTPUTS: none
!
!
!
! ROUTINE VALUE and
! COMPLETION CODES: integer, the delta time of the inputs
!
!
!
! SIDE EFFECTS: none to date
!
!
!
!--
          INTEGER FUNCTION DELTAT( start_time, end_time )

          character * 16 start_time, end_time

          integer  i_start_time(2), i_end_time(2)
          integer  quotient, difference(2), remainder
          integer  time, temp, status

          integer  LIB$SUBX, LIB$EDIV

          external LIB$SUBX, LIB$EDIV

          data time / 10 000 000 /

!++
! turn the two character strings into binary
!--
          decode( 16, 100, start_time ) i_start_time
100       format( 2Z8 )
          decode( 16, 100, end_time   ) i_end_time

!++
! make them into DEC's silly reversed format
!--
          temp = i_start_time(2)
          i_start_time(2) = i_start_time(1)
          i_start_time(1) = temp

          temp = i_end_time(2)
          i_end_time(2) = i_end_time(1)
          i_end_time(1) = temp

!++
! difference of the times
!--
          status = LIB$SUBX( i_end_time, i_start_time, difference, )

!++
! put into seconds
!--
          status = LIB$EDIV( time, difference, quotient, remainder )

          deltat = quotient

          return 
          end
