!
!			  COPYRIGHT (c) 1982 BY
!	      MOSTEK CORPORATION, CARROLLTON TX
!
! This software is furnished under a license and may be used and  copied
! only  in  accordance  with  the  terms  of  such  license and with the
! inclusion of the above copyright notice.  This software or  any  other
! copies  thereof may not be provided or otherwise made available to any
! other person.  No title to and ownership of  the  software  is  hereby
! transferred.
!
! The information in this software is subject to change  without  notice
! and  should  not  be  construed  as  a commitment by MOSTEK
! CORPORATION.
!
! MOSTEK assumes no responsibility for the use or  reliability  of  its
! software on equipment which is not supplied by MOSTEK.
!

!++
! FACILITY:
!   MOSTEK CORPORATION
!
! ABSTRACT: Turn a character representation of the system representation
!           of the time into human readable form
!   
!
! ENVIRONMENT: VAX VMS unpriv
!   
!
! AUTHOR:Gary Smith , CREATION DATE: 9/8/1982
!
! MODIFIED BY:
!
!--
!
! TABLE OF CONTENTS:
!
!
! INCLUDE FILES: none
!
!
! MACROS: none
!
!
! EQUATED SYMBOLS: none
!
!
! EXTERNAL REFERENCES: SYS$ASCTIM
!

!++
! FUNCTIONAL DESCRIPTION: KEY_TO_DATE turns a character representation of the
!                         system time into a human readable time of day
!
!
!
! FORMAL PARAMETERS: key_time -> the time to be converted
!
!
!
! IMPLICIT INPUTS: none
!
!
!
! IMPLICIT OUTPUTS: the day date and time in system format
!
!
!
! ROUTINE VALUE and
! COMPLETION CODES: none
!
!
!
! SIDE EFFECTS: none to date
!
!
!
!--
          CHARACTER * 23 FUNCTION key_to_date( key_time )

          character * 23 asc_tim
          character * 16 key_time

          integer  time(2)
          integer  temp, status

          integer  SYS$ASCTIM

          external SYS$ASCTIM

!++
! turn the time in chars into binary
!--

          decode( 16, 100, key_time, err=999 ) time
100       format( 2Z8 )

!++
! put into funny DEC format
!--
          temp = time(2)
          time(2) = time(1)
          time(1) = temp

!++
! make the change
!--
          status = SYS$ASCTIM( , asc_tim, time,  )

          key_to_date = asc_tim

          return 

!++
! input time was not capable of being converted, make blank
!--

999       continue

          key_to_date = ' '
          return
          end
