!
!			  COPYRIGHT (c) 1982 BY
!	      MOSTEK CORPORATION, CARROLLTON TX
!
! This software is furnished under a license and may be used and  copied
! only  in  accordance  with  the  terms  of  such  license and with the
! inclusion of the above copyright notice.  This software or  any  other
! copies  thereof may not be provided or otherwise made available to any
! other person.  No title to and ownership of  the  software  is  hereby
! transferred.
!
! The information in this software is subject to change  without  notice
! and  should  not  be  construed  as  a commitment by MOSTEK
! CORPORATION.
!
! MOSTEK assumes no responsibility for the use or  reliability  of  its
! software on equipment which is not supplied by MOSTEK.
!

!++
! FACILITY:
!   MOSTEK CORPORATION
!
! ABSTRACT: Fake out a quad word compare 
!   
!
! ENVIRONMENT: VAX VMS unpriv
!   
!
! AUTHOR: Gary Smith, CREATION DATE: 8/23/1982
!
! MODIFIED BY:
!
!--
!
! TABLE OF CONTENTS:
!
!
! INCLUDE FILES: statsubs.for
!
!
! MACROS: none
!
!
! EQUATED SYMBOLS: see statsubs.for
!
!
! EXTERNAL REFERENCES: none
!

!++
! FUNCTIONAL DESCRIPTION: KEY_COMPARE compares the first argument against
!                         the second to establish greater, less or equal
!                         based on the character representation of the 
!                         system time
!
!
! FORMAL PARAMETERS: first_arg  -> the testee
!                    second_arg -> the testor
!
!
!
! IMPLICIT INPUTS: none
!
!
!
! IMPLICIT OUTPUTS: none
!
!
!
! ROUTINE VALUE and
! COMPLETION CODES: -1  -> less
!                    0  -> equal
!                    1  -> greater
!
!
!
! SIDE EFFECTS:
!
!
!
!--
          INTEGER FUNCTION KEY_COMPARE( first_arg, second_arg )

          include 'statsubs.for'

          character * 16 first_arg, second_arg

!++
! make the comparison
!--

          if ( first_arg .gt. second_arg ) then
               key_compare = greater

          else if ( first_arg .eq. second_arg ) then
               key_compare = equal

          else if ( first_arg .lt. second_arg ) then
               key_compare = less

          endif

          return
          end
