!
!			  COPYRIGHT (c) 1982 BY
!	      MOSTEK CORPORATION, CARROLLTON TX
!
! This software is furnished under a license and may be used and  copied
! only  in  accordance  with  the  terms  of  such  license and with the
! inclusion of the above copyright notice.  This software or  any  other
! copies  thereof may not be provided or otherwise made available to any
! other person.  No title to and ownership of  the  software  is  hereby
! transferred.
!
! The information in this software is subject to change  without  notice
! and  should  not  be  construed  as  a commitment by MOSTEK
! CORPORATION.
!
! MOSTEK assumes no responsibility for the use or  reliability  of  its
! software on equipment which is not supplied by MOSTEK.
!

!++
! FACILITY:
!   MOSTEK CORPORATION
!
! ABSTRACT: MK$LENGTH returns the true length of a character string.
!           The true length is the length without trailing blanks or
!           nulls.
!   
!
! ENVIRONMENT: VAX VMS unpriv
!   
!
! AUTHOR: Gary Smith, CREATION DATE: 8/19/1982
!
! MODIFIED BY:
!
!--
!
! TABLE OF CONTENTS:
!
!
! INCLUDE FILES: none
!
!
! MACROS: none
!
!
! EQUATED SYMBOLS: none
!
!
! EXTERNAL REFERENCES: none
!

!++
! FUNCTIONAL DESCRIPTION: Take the string and count backwards until
!                         some character other than a blank or null is found.
!                         This is the strings real length.
!
!
!
! FORMAL PARAMETERS: The string in question
!
!
!
! IMPLICIT INPUTS: none
!
!
!
! IMPLICIT OUTPUTS: the length of the string without blanks or nulls
!
!
!
! ROUTINE VALUE and
! COMPLETION CODES: The string's real length
!
!
!
! SIDE EFFECTS: none to date
!
!
!
!--
      FUNCTION MK$LENGTH (STRING)

      character*(*) string

      MK$LENGTH = len(string)

!++
! count backwards from the end
!--

      do i = MK$LENGTH,1,-1
        if (ichar(string(i:i)) .ne.  '0'x  .and.
     +      ichar(string(i:i)) .ne. '20'x)  then
           MK$LENGTH = i
           return
        end if
      end do

      return
      end
