!++
! interval that mouse is to run in seconds
!--

          character * (*) ascii_delta_time
          parameter ( ascii_delta_time = '0 00:05:00.00' ) ! 5 minutes

!++ 
! sub for the name that MOUSE and STATS use for their performance file
!--

          character * (*) standard_nest_file
          parameter ( standard_nest_file = 'SYS$SYSTEM:RATSNEST.NST' )

!++
! subs for event flags used in MOUSE
!--

          parameter wait_ef   = 1
          parameter getdvi_ef = 2

!++
! sub for the key size
!--

          parameter key_size = 4
!++
! subs for job counts and cpu modes
!--
          parameter kernel =    1
          parameter super  =    2
          parameter exec   =    3
          parameter user   =    4
          parameter int    =    5
          parameter compat =    6
          parameter idle   =    7
          parameter bjobcnt =   8
          parameter ijobcnt =   9

          parameter cpu_size =  9
          parameter num_modes = 7

!++
! subs for file control primitives
!--
          parameter fcp_calls = 1
          parameter fcp_cache = 2
          parameter fcp_cpu   = 3
          parameter fcp_read  = 4
          parameter fcp_write = 5

          parameter fcp_size =  5

!++
! subs for miscellaneous statistics
!--
          parameter dirio     = 1
          parameter bufio     = 2
          parameter lognam    = 3
          parameter mbreads   = 4
          parameter mbwrites  = 5
          parameter turn      = 6
          parameter split     = 7
          parameter hit       = 8
          parameter opens     = 9
          parameter open      = 10
          parameter dirhit    = 11
          parameter dirmiss   = 12
          parameter exthit    = 13
          parameter extmiss   = 14
          parameter fidhit    = 15
          parameter fidmiss   = 16
          parameter quohit    = 17
          parameter quomiss   = 18

          parameter  misc_size = 18

!++
! subs for memory
!__
          parameter freecnt=1
          parameter mfycnt=2

          parameter mem_size = 2

!++
! subs for page faults
!--
          parameter dzroflts = 1
          parameter faults   = 2
          parameter preadio  = 3
          parameter pwritio  = 4
          parameter preads   = 5
          parameter pwrites  = 6
          parameter rdflts   = 7

          parameter pgflt_size = 7

!++
! subs for scheduler states
!--
          parameter colpg   = 1
          parameter mwait   = 2
          parameter cef     = 3
          parameter pfw     = 4
          parameter lef     = 5
          parameter lefo    = 6
          parameter hib     = 7
          parameter hibo    = 8
          parameter susp    = 9
          parameter suspo   = 10
          parameter fpg     = 11
          parameter com     = 12
          parameter como    = 13
          parameter cur     = 14

          parameter sch_size = 14

!++
! subs for swapping, last three cells are spares
!--
          parameter ispagcnt    = 1
          parameter iswpcnt     = 2
          parameter proccnt     = 3
          parameter oswpcnt     = 4
          parameter hoswpcnt    = 5
          parameter hiswpcnt    = 6

          parameter swap_size   = 9
          parameter swap_spares = 3

!++
! size for the uptime in longwords
!--
          parameter time_size = 2

!++
! size for "system response"
!--
          
          parameter response_size = 1
          parameter res           = 1

!++
! subs for DECnet
!--
          parameter arrlocpk = 1
          parameter arrtrapk = 2
          parameter deplocpk = 3
          parameter rcvbuffl = 4
          parameter trcnglos = 5

!++
! size for DECnet stats
!--
          parameter net_size = 5

!++
! subs for ENQ/DEQ
!--
          parameter enqnew   = 1
          parameter enqwait  = 2
          parameter deq      = 3
          parameter dlckfnd  = 4
          parameter dlcksrch = 5
          parameter enqcvt   = 6
          parameter enqnotqd = 7

!++
! size of lock_modes
!--
          parameter lock_size = 7


!++
! subs for the non-paged pool stats
!__

          parameter irpcnt    = 1          ! number of packets in IRP list
          parameter holecnt   = 2          ! number of memory blocks in pool
          parameter bighole   = 3          ! largest memory block
          parameter smallhole = 4          ! smallest memory block
          parameter smallcnt  = 5          ! number of 32 byte or smaller blocks
          parameter holesum   = 6          ! total space in non-paged pool
          parameter lrpcnt    = 7          ! number of LRPs
          parameter srpcnt    = 8          ! number of SRPs

!++
! size of pool modes
!--

          parameter pool_size = 8

!++
! total size of the MOUSE record
!--
          parameter rec_size = cpu_size + fcp_size + misc_size +
     .                         mem_size + pgflt_size +
     .                         sch_size + swap_size + time_size +
     .                         response_size + net_size + lock_size +
     .                         pool_size

