!
!			  COPYRIGHT (c) 1982 BY
!	      MOSTEK CORPORATION, CARROLLTON TX
!
! This software is furnished under a license and may be used and  copied
! only  in  accordance  with  the  terms  of  such  license and with the
! inclusion of the above copyright notice.  This software or  any  other
! copies  thereof may not be provided or otherwise made available to any
! other person.  No title to and ownership of  the  software  is  hereby
! transferred.
!
! The information in this software is subject to change  without  notice
! and  should  not  be  construed  as  a commitment by MOSTEK
! CORPORATION.
!
! MOSTEK assumes no responsibility for the use or  reliability  of  its
! software on equipment which is not supplied by MOSTEK.
!

!++
! FACILITY:
!   MOSTEK CORPORATION
!
! ABSTRACT:
!   STATFCP gathers the information the system keeps on File 
!   Control Primitives. STATFCP is really a front for the real 
!   worker, GETFCP.
!
! ENVIRONMENT:
!   VAX11 VMS
!
! AUTHOR: Gary Smith, CREATION DATE: 6/24/82
!
! MODIFIED BY:
!
!--
!
! TABLE OF CONTENTS:
!
!
! INCLUDE FILES:
!   mousesubs.for
!
! MACROS:
!   none
!
! EQUATED SYMBOLS:
!   see mousesubs.for
!
! EXTERNAL REFERENCES:
!   none

!++
! FUNCTIONAL DESCRIPTION:
!   Due to the funny nature of FCP's, this routine is merely a
!   front for the MACRO subroutine that does all the work.
!
! FORMAL PARAMETERS:
!   none
!
!
! IMPLICIT INPUTS:
!   fcp
!
!
! IMPLICIT OUTPUTS:
!   fcp
!
!
! ROUTINE VALUE and
! COMPLETION CODES:
!   none
!
!
! SIDE EFFECTS:
!   none to date
!
!
!--
          SUBROUTINE STATFCP !! collect FCP information

          include 'mousesubs.for'
          include 'defrec.for'

          integer  last(fcp_size), temp

          call GETFCP( rec_fcp(fcp_calls),
     .                 rec_fcp(fcp_cache),
     .                 rec_fcp(fcp_cpu  ),
     .                 rec_fcp(fcp_read ),
     .                 rec_fcp(fcp_write) )

!++
! compute the differences from the last time
!--
          do i = 1, fcp_size
             temp = rec_fcp(i)
             rec_fcp(i) = rec_fcp(i) - last(i)
             last(i) = temp
          end do

          return
          end
