!
!			  COPYRIGHT (c) 1982 BY
!	      MOSTEK CORPORATION, CARROLLTON TX
!
! This software is furnished under a license and may be used and  copied
! only  in  accordance  with  the  terms  of  such  license and with the
! inclusion of the above copyright notice.  This software or  any  other
! copies  thereof may not be provided or otherwise made available to any
! other person.  No title to and ownership of  the  software  is  hereby
! transferred.
!
! The information in this software is subject to change  without  notice
! and  should  not  be  construed  as  a commitment by MOSTEK
! CORPORATION.
!
! MOSTEK assumes no responsibility for the use or  reliability  of  its
! software on equipment which is not supplied by MOSTEK.
!

!++
! FACILITY:
!   MOSTEK CORPORATION
!
! ABSTRACT:
!   STATMEM gathers the information VMS keeps on itself about memory usage
!
! ENVIRONMENT:
!   VAX11 VMS   
!
! AUTHOR: Gary Smith, CREATION DATE: 6/24/82
!
! MODIFIED BY:
!
!--
!
! TABLE OF CONTENTS:
!
!
! INCLUDE FILES:
!   mousesubs.for
!
! MACROS:
!   none
!
! EQUATED SYMBOLS:
!   see mousesubs.for
!
! EXTERNAL REFERENCES:
!   SCH$GL_FREECNT          # of Pages on free list
!   SCH$GL_MFYCNT           # of Pages on modify list
!   ML$L_PEEK
!++
! FUNCTIONAL DESCRIPTION:
!   VMS keeps several locations for its own purposes to do with memory
!   management. STATMEM gathers up those locations and puts them into
!   mem_modes.
!
!
! FORMAL PARAMETERS:
!   none
!
!
! IMPLICIT INPUTS:
!   mem_modes
!
!
! IMPLICIT OUTPUTS:
!   mem_modes
!
!
! ROUTINE VALUE and
! COMPLETION CODES:
!   none
!
!
! SIDE EFFECTS:
!   none to date
!
!
!--
        SUBROUTINE STATMEM            !! Memory

          external SCH$GL_FREECNT         !! # of Pages on free list
          external SCH$GL_MFYCNT          !! # of Pages on modify list

          include  'mousesubs.for'
          include  'defrec.for'

!++
! grab the memory modes 
!--
          rec_mem_modes(freecnt)  = ML$L_PEEK(%LOC(SCH$GL_FREECNT))
          rec_mem_modes(mfycnt)   = ML$L_PEEK(%LOC(SCH$GL_MFYCNT))

          return
          end
