!
!			  COPYRIGHT (c) 1982 BY
!	      MOSTEK CORPORATION, CARROLLTON TX
!
! This software is furnished under a license and may be used and  copied
! only  in  accordance  with  the  terms  of  such  license and with the
! inclusion of the above copyright notice.  This software or  any  other
! copies  thereof may not be provided or otherwise made available to any
! other person.  No title to and ownership of  the  software  is  hereby
! transferred.
!
! The information in this software is subject to change  without  notice
! and  should  not  be  construed  as  a commitment by MOSTEK
! CORPORATION.
!
! MOSTEK assumes no responsibility for the use or  reliability  of  its
! software on equipment which is not supplied by MOSTEK.
!

!++
! FACILITY:
!   MOSTEK CORPORATION
!
! ABSTRACT:
!   Along with all the compartmentalized things that VMS keeps on itself
!   there are many things that don't fit any usual class. This procedure
!   collects all the flotsam and jetsam of VMS.   
!
! ENVIRONMENT:
!   VAX11 VMS   
!
! AUTHOR: Gary Smith, CREATION DATE: 6/24/82
!
! MODIFIED BY:
!
!--
!
! TABLE OF CONTENTS:
!
!
! INCLUDE FILES:
!   mousesubs.for
!
! MACROS:
!   none
!
! EQUATED SYMBOLS:
!   see mousesubs.for
!
! EXTERNAL REFERENCES:
!
!    PMS$GL_DIRIO         direct io
!    PMS$GL_BUFIO         buffered io
!    PMS$GL_LOGNAM        logical name translations
!    PMS$GL_MBREADS       mail box read
!    PMS$GL_MBWRITES      mail box writes
!    PMS$GL_TURN          number of window turns
!    PMS$GL_SPLIT         number of split i/o transfers
!    PMS$GL_HIT           number of transfers not requiring window turns
!    PMS$GL_OPENS         number of total file opens
!    PMS$GL_OPEN          number of files currently open
!    PMS$GL_DIRHIT        number of directory hits
!    PMS$GL_DIRMISS       number of directory misses
!    PMS$GL_EXTHIT        number of file extent hits
!    PMS$GL_EXTMISS       number of file extent misses
!    PMS$GL_FIDHIT        number of file name hits
!    PMS$GL_FIDMISS       number of file name misses
!    PMS$GL_QUOHIT        number of quota hits
!    PMS$GL_QUOMISS       number of quota misses
!    ML$L_PEEK
!++
! FUNCTIONAL DESCRIPTION:
!   Using ML$L_PEEK, gather up all the miscallaneous stats that VMS keeps
!   track of.
!
!
! FORMAL PARAMETERS:
!   none
!
!
! IMPLICIT INPUTS:
!   misc
!
!
! IMPLICIT OUTPUTS:
!   misc
!
!
! ROUTINE VALUE and
! COMPLETION CODES:
!   none
!
!
! SIDE EFFECTS:
!   none to date
!
!
!--
          SUBROUTINE STATMISC !!  miscellaneous stats

          external PMS$GL_DIRIO       !! direct io
          external PMS$GL_BUFIO       !! buffered io
          external PMS$GL_LOGNAM      !! logical name translations
          external PMS$GL_MBREADS     !! mail box read
          external PMS$GL_MBWRITES    !! mail box writes
          external PMS$GL_TURN        !! number of window turns
          external PMS$GL_SPLIT       !! number of split i/o transfers
          external PMS$GL_HIT         !! number of transfers w/o window
                                      !! turns
          external PMS$GL_OPENS       !! number of total file opens
          external PMS$GL_OPEN        !! number of files currently open
          external PMS$GL_DIRHIT      !! number of directory hits
          external PMS$GL_DIRMISS     !! number of directory misses
          external PMS$GL_EXTHIT      !! number of file extent hits
          external PMS$GL_EXTMISS     !! number of file extent misses
          external PMS$GL_FIDHIT      !! number of file name hits
          external PMS$GL_FIDMISS     !! number of file name misses
          external PMS$GL_QUOHIT      !! number of quota hits
          external PMS$GL_QUOMISS     !! number of quota misses

          include 'mousesubs.for'
          include 'defrec.for'

          integer  last(misc_size)

          rec_misc( dirio    ) =  ML$L_PEEK( %LOC( PMS$GL_DIRIO    ) )
          rec_misc( bufio    ) =  ML$L_PEEK( %LOC( PMS$GL_BUFIO    ) )
          rec_misc( lognam   ) =  ML$L_PEEK( %LOC( PMS$GL_LOGNAM   ) )
          rec_misc( mbreads  ) =  ML$L_PEEK( %LOC( PMS$GL_MBREADS  ) )
          rec_misc( mbwrites ) =  ML$L_PEEK( %LOC( PMS$GL_MBWRITES ) )
          rec_misc( turn     ) =  ML$L_PEEK( %LOC( PMS$GL_TURN     ) )
          rec_misc( split    ) =  ML$L_PEEK( %LOC( PMS$GL_SPLIT    ) )
          rec_misc( hit      ) =  ML$L_PEEK( %LOC( PMS$GL_HIT      ) )
          rec_misc( opens    ) =  ML$L_PEEK( %LOC( PMS$GL_OPENS    ) )
          rec_misc( open     ) =  ML$L_PEEK( %LOC( PMS$GL_OPEN     ) )
          rec_misc( dirhit   ) =  ML$L_PEEK( %LOC( PMS$GL_DIRHIT   ) )
          rec_misc( dirmiss  ) =  ML$L_PEEK( %LOC( PMS$GL_DIRMISS  ) )
          rec_misc( exthit   ) =  ML$L_PEEK( %LOC( PMS$GL_EXTHIT   ) )
          rec_misc( extmiss  ) =  ML$L_PEEK( %LOC( PMS$GL_EXTMISS  ) )
          rec_misc( fidhit   ) =  ML$L_PEEK( %LOC( PMS$GL_FIDHIT   ) )
          rec_misc( fidmiss  ) =  ML$L_PEEK( %LOC( PMS$GL_FIDMISS  ) )
          rec_misc( quohit   ) =  ML$L_PEEK( %LOC( PMS$GL_QUOHIT   ) )
          rec_misc( quomiss  ) =  ML$L_PEEK( %LOC( PMS$GL_QUOMISS  ) )

          do i = 1, misc_size
             if ( i .ne. open ) then
                temp = rec_misc(i)
                rec_misc(i) = rec_misc(i) - last(i)
                last(i) = temp
             end if
          end do

          return
          end
