!
!			  COPYRIGHT (c) 1982 BY
!	      MOSTEK CORPORATION, CARROLLTON TX
!
! This software is furnished under a license and may be used and  copied
! only  in  accordance  with  the  terms  of  such  license and with the
! inclusion of the above copyright notice.  This software or  any  other
! copies  thereof may not be provided or otherwise made available to any
! other person.  No title to and ownership of  the  software  is  hereby
! transferred.
!
! The information in this software is subject to change  without  notice
! and  should  not  be  construed  as  a commitment by MOSTEK
! CORPORATION.
!
! MOSTEK assumes no responsibility for the use or  reliability  of  its
! software on equipment which is not supplied by MOSTEK.
!

!++
! FACILITY:
!   MOSTEK CORPORATION
!
! ABSTRACT: STATNET gathers the DECnet info that is kept by VMS.
!   
!
! ENVIRONMENT: VAX VMS unprivileged
!   
!
! AUTHOR: Gary Smith, CREATION DATE: 8/18/1982
!
! MODIFIED BY:
!
!--
!
! TABLE OF CONTENTS:
!
!
! INCLUDE FILES: mousesubs.for
!                defrec.for
!
!
! MACROS: none
!
!
! EQUATED SYMBOLS: see mousesubs.for
!
!
! EXTERNAL REFERENCES:
!
!          PMS$GL_ARRLOCPK -> arriving local packet count
!          PMS$GL_ARRTRAPK -> arriving trans packet count
!          PMS$GL_DEPLOCPK -> departing local packet count
!          PMS$GL_RCVBUFFL -> receive buffer fail count
!          PMS$GL_TRCNGLOS -> transmit congestion loss

!++
! FUNCTIONAL DESCRIPTION: DECnet is now an integral part of VMS with 3.0
!                         and thus the OS keeps stats on it. STATNET gathers
!                         these stats with the aid of ML$L_PEEK. These are
!                         kept as a difference measurement.
!
!
! FORMAL PARAMETERS: none
!
!
!
! IMPLICIT INPUTS: none
!
!
!
! IMPLICIT OUTPUTS: net_modes
!
!
!
! ROUTINE VALUE and
! COMPLETION CODES: none
!
!
!
! SIDE EFFECTS: none to date
!
!
!
!--
          SUBROUTINE STATNET

          include 'mousesubs.for'
          include 'defrec.for'

          external PMS$GL_ARRLOCPK
          external PMS$GL_ARRTRAPK
          external PMS$GL_DEPLOCPK
          external PMS$GL_RCVBUFFL
          external PMS$GL_TRCNGLOS

          external ML$L_PEEK

          integer  ML$L_PEEK
          integer  last(net_size), temp

!++
! Gather up the DECnet stats
!--

          rec_net_modes(arrlocpk) = ML$L_PEEK( %LOC( PMS$GL_ARRLOCPK ) )
          rec_net_modes(arrtrapk) = ML$L_PEEK( %LOC( PMS$GL_ARRTRAPK ) )
          rec_net_modes(deplocpk) = ML$L_PEEK( %LOC( PMS$GL_DEPLOCPK ) )
          rec_net_modes(rcvbuffl) = ML$L_PEEK( %LOC( PMS$GL_RCVBUFFL ) )
          rec_net_modes(trcnglos) = ML$L_PEEK( %LOC( PMS$GL_TRCNGLOS ) )

!++
! Compute the delta from the last time
!--

          do i = 1, net_size
               temp = rec_net_modes(i)
               rec_net_modes(i) = rec_net_modes(i) - last(i)
               last(i) = temp
          end do

          return
          end
