!
!			  COPYRIGHT (c) 1982 BY
!	      MOSTEK CORPORATION, CARROLLTON TX
!
! This software is furnished under a license and may be used and  copied
! only  in  accordance  with  the  terms  of  such  license and with the
! inclusion of the above copyright notice.  This software or  any  other
! copies  thereof may not be provided or otherwise made available to any
! other person.  No title to and ownership of  the  software  is  hereby
! transferred.
!
! The information in this software is subject to change  without  notice
! and  should  not  be  construed  as  a commitment by MOSTEK
! CORPORATION.
!
! MOSTEK assumes no responsibility for the use or  reliability  of  its
! software on equipment which is not supplied by MOSTEK.
!

!++
! FACILITY:
!   MOSTEK CORPORATION
!
! ABSTRACT:
!   STATPGFLT gets the page fault statistics.   
!
! ENVIRONMENT:
!   VAX11 VMS   
!
! AUTHOR: Gary Smith, CREATION DATE: 6/24/82
!
! MODIFIED BY:
!
!--
!
! TABLE OF CONTENTS:
!
!
! INCLUDE FILES:
!   mousesubs.for
!
! MACROS:
!   none
!
! EQUATED SYMBOLS:
!   see mousesubs.for
!
! EXTERNAL REFERENCES:
!
!   PMS$GL_DZROFLTS     !! demand zero faults
!   PMS$GL_FAULTS       !! page faults
!   PMS$GL_PREADIO      !! page reads io
!   PMS$GL_PWRITIO      !! page writes io
!   PMS$GL_PREADS       !! page reads
!   PMS$GL_PWRITES      !! page writes
!   PMS$GL_RDFLTS       !! page read faults
!   ML$L_PEEK
!
!++
! FUNCTIONAL DESCRIPTION:
!   VMS keeps several locations of information about the page faulting
!   that is going on in the system. Using ML$L_PEEK, store off these
!   places into pgflt.
!
!
! FORMAL PARAMETERS:
!   none
!
!
! IMPLICIT INPUTS:
!   pgflt
!
!
! IMPLICIT OUTPUTS:
!   pgflt
!
!
! ROUTINE VALUE and
! COMPLETION CODES:
!   none
!
!
! SIDE EFFECTS:
!   none to date
!
!
!--
          SUBROUTINE STATPGFLT !! Page fault stats

          external PMS$GL_DZROFLTS     !! demand zero faults
          external PMS$GL_FAULTS       !! page faults
          external PMS$GL_PREADIO      !! page reads io
          external PMS$GL_PWRITIO      !! page writes io
          external PMS$GL_PREADS       !! page reads
          external PMS$GL_PWRITES      !! page writes
          external PMS$GL_RDFLTS       !! page read faults

          include 'mousesubs.for'
          include 'defrec.for'

          integer last(pgflt_size), temp
!++
! grab up all the page fault stats and leave
!--
          rec_pgflt( dzroflts ) = ML$L_PEEK( %LOC( PMS$GL_DZROFLTS ) )
          rec_pgflt( faults   ) = ML$L_PEEK( %LOC( PMS$GL_FAULTS   ) )
          rec_pgflt( preadio  ) = ML$L_PEEK( %LOC( PMS$GL_PREADIO  ) )
          rec_pgflt( pwritio  ) = ML$L_PEEK( %LOC( PMS$GL_PWRITIO  ) )
          rec_pgflt( preads   ) = ML$L_PEEK( %LOC( PMS$GL_PREADS   ) )
          rec_pgflt( pwrites  ) = ML$L_PEEK( %LOC( PMS$GL_PWRITES  ) )
          rec_pgflt( rdflts   ) = ML$L_PEEK( %LOC( PMS$GL_RDFLTS   ) )

!++ 
! compute the differences between now and the last time
!--
          do i = 1, pgflt_size
             temp = rec_pgflt(i)
             rec_pgflt(i) = rec_pgflt(i) - last(i)
             last(i) = temp
          enddo

          return
          end
