!
!			  COPYRIGHT (c) 1982 BY
!	      MOSTEK CORPORATION, CARROLLTON TX
!
! This software is furnished under a license and may be used and  copied
! only  in  accordance  with  the  terms  of  such  license and with the
! inclusion of the above copyright notice.  This software or  any  other
! copies  thereof may not be provided or otherwise made available to any
! other person.  No title to and ownership of  the  software  is  hereby
! transferred.
!
! The information in this software is subject to change  without  notice
! and  should  not  be  construed  as  a commitment by MOSTEK
! CORPORATION.
!
! MOSTEK assumes no responsibility for the use or  reliability  of  its
! software on equipment which is not supplied by MOSTEK.
!

!++
! FACILITY:
!   MOSTEK CORPORATION
!
! ABSTRACT:
!   STATPOOL functions like STATFCP does, it is a front for another
!   subroutine that does all the work.
!
! ENVIRONMENT:
!   VAX11 VMS, Kernel mode with interrupts disabled in the call routine
!
! AUTHOR: Gary Smith, CREATION DATE: 6/24/82
!
! MODIFIED BY:
!
!--
!
! TABLE OF CONTENTS:
!
!
! INCLUDE FILES:
!   mousesubs.for
!   defrec.for
!
! MACROS:
!   none
!
! EQUATED SYMBOLS:
!   none
!
! EXTERNAL REFERENCES:
!   GETPOOL
!
!++
! FUNCTIONAL DESCRIPTION:
!   To gather the non paged pool statistics, it is necessary to go into
!   kernel mode. Then once in kernel mode, disable interrupts for a 
!   short period of time in which you quickly get all the facts about 
!   the non-paged pool. Then enable interrupts and return by a RET
!   and in so doing, leave kernel mode intact.
!
!
! FORMAL PARAMETERS:
!   none
!
!
! IMPLICIT INPUTS:
!   pool
!
!
! IMPLICIT OUTPUTS:
!   pool
!
!
! ROUTINE VALUE and
! COMPLETION CODES:
!   none
!
!
! SIDE EFFECTS:
!   During development, the beastie had a tendency to crash the
!   system and make its creator unpopular.
!
!
!--
          SUBROUTINE STATPOOL !! collect non-paged pool information

          include 'mousesubs.for'
          include 'defrec.for'

          call GETPOOL( rec_pool_modes(holecnt),
     .                  rec_pool_modes(holesum),
     .                  rec_pool_modes(bighole),
     .                  rec_pool_modes(smallcnt),
     .                  rec_pool_modes(smallhole),
     .                  rec_pool_modes(irpcnt),
     .                  rec_pool_modes(lrpcnt),
     .                  rec_pool_modes(srpcnt) )


          return
          end
