!
!			  COPYRIGHT (c) 1982 BY
!	      MOSTEK CORPORATION, CARROLLTON TX
!
! This software is furnished under a license and may be used and  copied
! only  in  accordance  with  the  terms  of  such  license and with the
! inclusion of the above copyright notice.  This software or  any  other
! copies  thereof may not be provided or otherwise made available to any
! other person.  No title to and ownership of  the  software  is  hereby
! transferred.
!
! The information in this software is subject to change  without  notice
! and  should  not  be  construed  as  a commitment by MOSTEK
! CORPORATION.
!
! MOSTEK assumes no responsibility for the use or  reliability  of  its
! software on equipment which is not supplied by MOSTEK.
!

!++
! FACILITY:
!   MOSTEK CORPORATION
!
! ABSTRACT:
!     STATRESP calculates a  a "response value" for the running system.
!
! ENVIRONMENT:
!     VAX 11 VMS
!
! AUTHOR: Gary Smith, CREATION DATE: 7/15/1982
!
! MODIFIED BY:
!
!--
!
! TABLE OF CONTENTS:
!
!
! INCLUDE FILES:
!     mousesubs.for
!     defrec.for
!
! MACROS:
!     none
!
! EQUATED SYMBOLS:
!     see mousesubs.for
!
! EXTERNAL REFERENCES:
!     LIB$INIT_TIMER, LIB$STAT_TIMER, LIB$EDIV

!++
! FUNCTIONAL DESCRIPTION:
!     When MOUSE wakes up to do it's gathering, it calls STATRESP immediately.
!     STATRESP is initializes several variables for the cpu time and the 
!     elapsed time. After MOUSE is thru gathering and collecting its data,
!     STATRESP is again called to figure out the elapsed time it took
!     to gather the stats and the cpu time it really used. The quotient
!     of these two values is the "response".
!
! FORMAL PARAMETERS:
!     code; whether to initialize or calculate. 
!
!
! IMPLICIT INPUTS:
!     none
!
!
! IMPLICIT OUTPUTS:
!     response
!
!
! ROUTINE VALUE and
! COMPLETION CODES:
!
!
!
! SIDE EFFECTS:
!     none to date
!
!
!--
      SUBROUTINE STATRESP ( code )

      include 'mousesubs.for'
      include 'defrec.for'

      integer code, status, quad_time(2), time
      integer LIB$INIT_TIMER, LIB$STAT_TIMER, LIB$EDIV

      external LIB$INIT_TIMER, LIB$STAT_TIMER, LIB$EDIV

      goto ( 100, 200 ) code
!++
! do initialization
!--

100   status = LIB$INIT_TIMER()
      return

!++
! compute response
!--

200   status = LIB$STAT_TIMER( 1, quad_time, )
      status = LIB$STAT_TIMER( 2, i_cpu_time )
      real_cpu_time = i_cpu_time
      status = LIB$EDIV( 100 000, quad_time, time, left_over )
      rec_response = ( time / real_cpu_time ) * 100
      return
      end   
