!
!			  COPYRIGHT (c) 1982 BY
!	      MOSTEK CORPORATION, CARROLLTON TX
!
! This software is furnished under a license and may be used and  copied
! only  in  accordance  with  the  terms  of  such  license and with the
! inclusion of the above copyright notice.  This software or  any  other
! copies  thereof may not be provided or otherwise made available to any
! other person.  No title to and ownership of  the  software  is  hereby
! transferred.
!
! The information in this software is subject to change  without  notice
! and  should  not  be  construed  as  a commitment by MOSTEK
! CORPORATION.
!
! MOSTEK assumes no responsibility for the use or  reliability  of  its
! software on equipment which is not supplied by MOSTEK.
!

!++
! FACILITY:
!   MOSTEK CORPORATION
!
! ABSTRACT:
!   STATSCH gathers the information on the the scheduler states system
!   wide.
!
! ENVIRONMENT:
!   VAX11 VMS
!
! AUTHOR: Gary Smith, CREATION DATE: 6/24/82
!
! MODIFIED BY:
!
!--
!
! TABLE OF CONTENTS:
!
!
! INCLUDE FILES:
!   mousesubs.for
!
! MACROS:
!   none
!
! EQUATED SYMBOLS:
!   see mousesubs.for
!
! EXTERNAL REFERENCES:
!   SYS$GETJPI
!   JPI$_STATE
!   JPI$_PID
!   SS$_NOMOREPROC
!

!++
! FUNCTIONAL DESCRIPTION:
!   Every process in the system is in one of the various scheduler
!   states. By  running thru all the processes in the system, and
!   examining their state of scheduling, we form the output of the 
!   subroutine, sch_state.
!
!
! FORMAL PARAMETERS:
!   none
!
!
! IMPLICIT INPUTS:
!   sch_state
!
!
! IMPLICIT OUTPUTS:
!   sch_state
!
!
! ROUTINE VALUE and
! COMPLETION CODES:
!   none
!
!
! SIDE EFFECTS:
!   none  to date.
!
!
!--
          SUBROUTINE STATSCH !! Scheduler states


          external SYS$GETJPI
          external JPI$_STATE
          external JPI$_PID
          external SS$_NOMOREPROC

          include 'mousesubs.for'
          include 'defrec.for'

          integer pid_search, status, SYS$GETJPI
          integer prc_state, pid, state_item_list(3), pid_item_list(3)

          pid_search = -1

          do i = 1, sch_size
             rec_sch_state(i) = 0
          enddo

!++
! set up the control block for retrieving the pid
!--
          pid_item_list(1) = 4 + %LOC(JPI$_PID) * (2**16) 
          pid_item_list(2) = %LOC(pid)
          status = SYS$GETJPI( %VAL(0), pid_search, %VAL(0),
     .                         pid_item_list, %VAL(0), %VAL(0),
     .                         %VAL(0) )

!++
! set up the control block for retrieving the scheduler state
!--

          state_item_list(1) = 4 + %LOC(JPI$_STATE) * (2**16)
          state_item_list(2) = %LOC(prc_state)

!++
! go thru all the processes there are and record their state
!--

          do while ( status .ne. %LOC(SS$_NOMOREPROC) )
             status = SYS$GETJPI( %VAL(0), pid, %VAL(0),
     .                            state_item_list, %VAL(0), %VAL(0),
     .                            %VAL(0) )
             rec_sch_state(prc_state) = rec_sch_state(prc_state) + 1
             pid_item_list(1) = 4 + %LOC(JPI$_PID) * (2**16) 
             pid_item_list(2) = %LOC(pid)
             status = SYS$GETJPI( %VAL(0), pid_search, %VAL(0),
     .                            pid_item_list, %VAL(0), %VAL(0),
     .                            %VAL(0) )
             state_item_list(1) = 4 + %LOC(JPI$_STATE) * (2**16)
             state_item_list(2) = %LOC(prc_state)
          end do

          return
          end
