!
!			  COPYRIGHT (c) 1982 BY
!	      MOSTEK CORPORATION, CARROLLTON TX
!
! This software is furnished under a license and may be used and  copied
! only  in  accordance  with  the  terms  of  such  license and with the
! inclusion of the above copyright notice.  This software or  any  other
! copies  thereof may not be provided or otherwise made available to any
! other person.  No title to and ownership of  the  software  is  hereby
! transferred.
!
! The information in this software is subject to change  without  notice
! and  should  not  be  construed  as  a commitment by MOSTEK
! CORPORATION.
!
! MOSTEK assumes no responsibility for the use or  reliability  of  its
! software on equipment which is not supplied by MOSTEK.
!

!++
! FACILITY:
!   MOSTEK CORPORATION
!
! ABSTRACT:
!   STATSWAP chases down all the swap statistics. In version 3.0 of
!   VMS, swapping is supposedly going away. This may become excess
!   baggage.
!
! ENVIRONMENT:
!   VAX11 VMS
!
! AUTHOR: Gary Smith, CREATION DATE: 6/24/82
!
! MODIFIED BY:
!
!--
!
! TABLE OF CONTENTS:
!
!
! INCLUDE FILES:
!   mousesubs.for
!   defrec.for
!
! MACROS:
!   none
!
! EQUATED SYMBOLS:
!   see mousesubs.for
!
! EXTERNAL REFERENCES:
!   SWP$GL_ISPAGCNT     Inswap page count
!   SWP$GL_ISWPCNT      Count of inswap performed
!   SCH$GW_PROCCNT      Count of processes that require swap file
!   SWP$GL_OSWPCNT      Count of outswaps performed
!   SWP$GL_HOSWPCNT     Count of header outswaps
!   SWP$GL_HISWPCNT     Count of header inswaps
!

!++
! FUNCTIONAL DESCRIPTION:
!   STATSWAP grabs the information about swapping that is going on
!   in the system.
!
!
! FORMAL PARAMETERS:
!   none
!
!
! IMPLICIT INPUTS:
!   swap
!
!
! IMPLICIT OUTPUTS:
!   swap
!
!
! ROUTINE VALUE and
! COMPLETION CODES:
!   none
!
!
! SIDE EFFECTS:
!   none to date
!
!
!--
          SUBROUTINE STATSWAP     !! Stats on swapping

          external SWP$GL_ISPAGCNT  !! Inswap page count
          external SWP$GL_ISWPCNT   !! Count of inswap performed
          external SCH$GW_PROCCNT   !! Count of processes that require swap file
          external SWP$GL_OSWPCNT   !! Count of outswaps performed
          external SWP$GL_HOSWPCNT  !! Count of header outswaps
          external SWP$GL_HISWPCNT  !! Count of header inswaps

          include 'mousesubs.for'
          include 'defrec.for'

          integer last(swap_size), temp

!++
! grap up the swapping stats
!__
          rec_swap(ispagcnt) = ML$L_PEEK(%LOC(SWP$GL_ISPAGCNT))
          rec_swap(iswpcnt ) = ML$L_PEEK(%LOC(SWP$GL_ISWPCNT ))
          rec_swap(proccnt ) = ML$L_PEEK(%LOC(SCH$GW_PROCCNT )) .and. 
     .                     'ffff'x
          rec_swap(oswpcnt ) = ML$L_PEEK(%LOC(SWP$GL_OSWPCNT ))
          rec_swap(hoswpcnt) = ML$L_PEEK(%LOC(SWP$GL_HOSWPCNT))
          rec_swap(hiswpcnt) = ML$L_PEEK(%LOC(SWP$GL_HISWPCNT))

!++
! Compute the delta from the last time. Note the special casing for
! ispagcnt and proccnt
!--

          do i = 1, swap_size - swap_spares
             if ( (i .ne. ispagcnt) .and. (i .ne. proccnt) ) then
                temp = rec_swap(i)
                rec_swap(i) = rec_swap(i) - last(i)
                last(i) = temp
             end if
          end do

          return 
          end
