!
!			  COPYRIGHT (c) 1982 BY
!	      MOSTEK CORPORATION, CARROLLTON TX
!
! This software is furnished under a license and may be used and  copied
! only  in  accordance  with  the  terms  of  such  license and with the
! inclusion of the above copyright notice.  This software or  any  other
! copies  thereof may not be provided or otherwise made available to any
! other person.  No title to and ownership of  the  software  is  hereby
! transferred.
!
! The information in this software is subject to change  without  notice
! and  should  not  be  construed  as  a commitment by MOSTEK
! CORPORATION.
!
! MOSTEK assumes no responsibility for the use or  reliability  of  its
! software on equipment which is not supplied by MOSTEK.
!

!++
! FACILITY:
!   MOSTEK CORPORATION
!
! ABSTRACT: STD calculates the standard deviation.
!   
!
! ENVIRONMENT: VAX/VMS unpriv
!   
!
! AUTHOR: Gary Smith, CREATION DATE: 4/20/83
!
! MODIFIED BY:
!
!--
!
! TABLE OF CONTENTS:
!
!
! INCLUDE FILES: none
!
!
! MACROS: none
!
!
! EQUATED SYMBOLS: none
!
!
! EXTERNAL REFERENCES: none
!

!++
! FUNCTIONAL DESCRIPTION: STD receives the sum of the values squared,
!                         the sum of the values, and the number of values.
!                         This goes into the standard formula for STD.
!
!
!
! FORMAL PARAMETERS: bar   -> the sum of the values**2
!                    set   -> the sum of the values
!                    count -> how many values there are
!
!
!
! IMPLICIT INPUTS: none
!
!
!
! IMPLICIT OUTPUTS: none
!
!
!
! ROUTINE VALUE and
! COMPLETION CODES: the standard deviation
!
!
!
! SIDE EFFECTS: none to date
!
!
!
!--
          REAL FUNCTION STD(  BAR, SET, COUNT )

          real * 8 bar, set

          integer count

!++
! compute the STD as square_root( x**2_bar - (x_bar)**2 )
!--

          std = sqrt( (bar/count) - ((set/count) ** 2) )
          return
          end
