!
!			  COPYRIGHT (c) 1982 BY
!	      MOSTEK CORPORATION, CARROLLTON TX
!
! This software is furnished under a license and may be used and  copied
! only  in  accordance  with  the  terms  of  such  license and with the
! inclusion of the above copyright notice.  This software or  any  other
! copies  thereof may not be provided or otherwise made available to any
! other person.  No title to and ownership of  the  software  is  hereby
! transferred.
!
! The information in this software is subject to change  without  notice
! and  should  not  be  construed  as  a commitment by MOSTEK
! CORPORATION.
!
! MOSTEK assumes no responsibility for the use or  reliability  of  its
! software on equipment which is not supplied by MOSTEK.
!

!++
! FACILITY:
!   MOSTEK CORPORATION
!
! ABSTRACT: All input from the terminal is solicited form this routine
!           only.
!   
!
! ENVIRONMENT: VAX VMS unpriv
!   
!
! AUTHOR: Gary Smith, CREATION DATE: 8/19/1952
!
! MODIFIED BY:
!
!--
!
! TABLE OF CONTENTS:
!
!
! INCLUDE FILES: none
!
!
! MACROS: none
!
!
! EQUATED SYMBOLS: none
!
!
! EXTERNAL REFERENCES: STR$UPCASE, msg_inlilenex
!

!++
! FUNCTIONAL DESCRIPTION: TERMINAL_READ accepts input from the command
!                         stream. 
!
!
!
! FORMAL PARAMETERS: in        ->  the input command buffer
!                    kf        ->  where the string starts in 'in'
!                    len       ->  how long 'in' is
!
!
!
! IMPLICIT INPUTS: batch -> is STATS running in batch mode
!
!
!
! IMPLICIT OUTPUTS: none
!
!
!
! ROUTINE VALUE and
! COMPLETION CODES: none
!
!
!
! SIDE EFFECTS: none to date
!
!
!
!--
          SUBROUTINE Terminal_read( in, kf, len )

          dimension in(256)

          logical batch
          integer in_unit, out_unit
          integer start, status

          external STR$UPCASE, msg_inlilenex

          integer STR$UPCASE

          logical*1 input(256), fake(256)

          common / io_com / in_unit, out_unit, batch
!++
! prompt the STATS user
!--
          start=1
          if ( .not. batch ) write(out_unit, 20)
20        format($, ' STATS> ' )

!++
! clear any information left in the psuedo and real buffers
!--
          do 40 i=1,256
             fake(i)=32
             in(i)=32
40        continue

!++
! read in the string
!--

60        read(in_unit,80,end=180,err=160) len,(fake(i),i=1,256)
80        format(q,256a1)

!++
! check for over run on input line
!--
          if ( len+start .gt. 256 ) then
             call LIB$SIGNAL( msg_inlilenex )
             return
          end if
          if ( len .eq. 0 ) return

!++
! check for continuation
!--
          if ( fake(len) .eq. 45 ) then

!++
! copy fake into in except for the continuation mark
!--
             do i=start, start+len-2
                in(i)=fake(i-start+1)
             end do

!++
! go back for more
!--
             start=len+start-1
             write(out_unit,120)
120          format($,' STATS>_')
             goto 60
          else

!++
! no continuation mark found
!--
             do i=start,start+len-1
                in(i)=fake(i-start+1)
             end do
          end if
          len=start+len-1
          if ( batch ) write( out_unit, 130 ) ( in(i), i=1,len )
130       format( ' STATS> ', <len>A )
          status = STR$UPCASE( %DESCR(in), %DESCR(in) )
          return

!++
! something faulty happened; exit
!--
160       stop 'Error on input, STATS exiting...'
180       stop 'STATS exiting...'
          end
