$       SET NOON
$ !--------------------------------------------------------------------!
$ !     Procedure:     CONFIGNET                                       !
$ !--------------------------------------------------------------------!
$ !     System:        VAX/VMS V3.1 DCL                                !
$ !--------------------------------------------------------------------!
$ !     Programmer:    Kevin Klughart                                  !
$ !--------------------------------------------------------------------!
$ !     Date:          01-28-83 @ 14:00 CDST                           !
$ !--------------------------------------------------------------------!
$ !     Application:   VAX/VMS DECnet V3.0 (PHASE III) Network         !
$ !                    definition procedure file.                      !
$ !--------------------------------------------------------------------!
$ !     Purpose:       This procedure file represents the site         !
$ !                    specific definition of the network executor     !
$ !                    local node.  This file is to reside in the      !
$ !                    Mostek site dependent MKL$NETWORK directory     !
$ !                    and must be protected from the general user     !
$ !                    population.  No modifications are to be made    !
$ !                    to this file by anyone other than Mostek        !
$ !                    network management personnel.                   !
$ !                                                                    !
$ !                    *** This file is under configuration control ***!
$ !--------------------------------------------------------------------!
$ !
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !                                                                    !
$ !     Begin Executor Node Configuration Procedure                    !
$ !                                                                    !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Inform user of network configuration procedure execution       !
$ !--------------------------------------------------------------------!
$       WRITE SYS$OUTPUT "***  Mostek DECnet Executor Configuration Procedure  ***"
$       WRITE SYS$OUTPUT " "
$       WRITE SYS$OUTPUT " "
$       WRITE SYS$OUTPUT " "
$ !--------------------------------------------------------------------!
$ !     Define network configuration program (NCP) image               !
$ !--------------------------------------------------------------------!
$       NCP :== $ NCP
$ !--------------------------------------------------------------------!
$ !     Determine password of network privileged user account          !
$ !--------------------------------------------------------------------!
$       NETPRV_PSWD := "''P1'"
$       IF (NETPRV_PSWD .EQS. "") THEN -
                INQUIRE NETPRV_PSWD "Enter network privileged user password"
$ !
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !                                                                    !
$ !     Load the network driver                                        !
$ !                                                                    !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$       WRITE SYS$OUTPUT " "
$       WRITE SYS$OUTPUT "***  Loading the network driver  ***"
$       WRITE SYS$OUTPUT " "
$
$       RUN SYS$SYSTEM:SYSGEN
                CONNECT NET /NOADAPTER /DRIVER=NETDRIVER
$ !
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !                                                                    !
$ !     Shutdown current network                                       !
$ !                                                                    !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$       NETNOD = F$LOGICAL("SYS$NODE")
$       NETLEN = F$LENGTH(NETNOD)
$       IF (NETLEN .EQ. 0) THEN GOTO PRGE
$
$       WRITE SYS$OUTPUT " "
$       WRITE SYS$OUTPUT "***  Shutting down current network  ***"
$       WRITE SYS$OUTPUT " "
$
$       NCP SET EXECUTOR STATE SHUT
$       WAIT 00:00:15
$ !
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !                                                                    !
$ !     Purge the current network configuration                        !
$ !                                                                    !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ PRGE: WRITE SYS$OUTPUT "***  Please wait for network configuration  ***"
$
$       NCP PURGE KNOWN LINES ALL
$       NCP PURGE KNOWN CIRCUITS ALL
$       NCP PURGE KNOWN LOGGING ALL
$       NCP PURGE KNOWN NODES ALL
$       NCP PURGE KNOWN OBJECTS ALL
$
$       WRITE SYS$OUTPUT " "
$       WRITE SYS$OUTPUT "***  Current network configuration purged  ***"
$ !
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !                                                                    !
$ !     Define the new network local, remotes, circuits and lines      !
$ !                                                                    !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$       NCP DEFINE EXECUTOR ADDRESS 022
$       NCP DEFINE EXECUTOR NAME OPSPLN
$       NCP DEFINE EXECUTOR BUFFER SIZE 576
$       NCP DEFINE EXECUTOR COUNTER TIMER 65535
$       NCP DEFINE EXECUTOR DELAY FACTOR 128
$       NCP DEFINE EXECUTOR DELAY WEIGHT 8
$       NCP DEFINE EXECUTOR IDENTIFICATION "Operation Planning Systems"
$       NCP DEFINE EXECUTOR INACTIVITY TIMER 120
$       NCP DEFINE EXECUTOR INCOMING TIMER 120
$       NCP DEFINE EXECUTOR MAXIMUM ADDRESS 32
$       NCP DEFINE EXECUTOR MAXIMUM BUFFERS 64
$       NCP DEFINE EXECUTOR MAXIMUM COST 64
$       NCP DEFINE EXECUTOR MAXIMUM HOPS 8
$       NCP DEFINE EXECUTOR MAXIMUM CIRCUITS 4
$       NCP DEFINE EXECUTOR MAXIMUM VISITS 16
$       NCP DEFINE EXECUTOR OUTGOING TIMER 120
$       NCP DEFINE EXECUTOR PIPELINE QUOTA 6000
$       NCP DEFINE EXECUTOR RETRANSMIT FACTOR 20
$       NCP DEFINE EXECUTOR ROUTING TIMER 1200
$       NCP DEFINE EXECUTOR NONPRIVILEGED USER NETUSR PASSWORD NETUSR
$       NCP DEFINE EXECUTOR PRIVILEGED USER NETPRV PASSWORD 'NETPRV_PSWD'
$       NCP DEFINE EXECUTOR PROXY ACCESS BOTH
$       NCP DEFINE EXECUTOR DEFAULT PROXY BOTH
$       NCP DEFINE EXECUTOR STATE ON
$ !
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !                                                                    !
$ !     Define network communication links                             !
$ !                                                                    !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Line costs are computed as follows:                            !
$ !                                                                    !
$ !     Devices with a speed over 100000 baud have a cost of 1         !
$ !     Devices with a speed uner 100000 baud have a cost of 100000/X  !
$ !             where "X" is the speed of the device in baud.          !
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Define connecting line (56kb DMC-11)                           !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$       NCP DEFINE LINE DMC-0 PROTOCOL DDCMP DMC
$       NCP DEFINE LINE DMC-0 CONTROLLER NORMAL
$       NCP DEFINE LINE DMC-0 COUNTER TIMER 65535
$       NCP DEFINE LINE DMC-0 DUPLEX FULL
$       NCP DEFINE LINE DMC-0 NORMAL TIMER 30000
$       NCP DEFINE LINE DMC-0 RECEIVE BUFFERS 16
$       NCP DEFINE LINE DMC-0 SERVICE TIMER 30000
$       NCP DEFINE LINE DMC-0 STATE ON
$
$       NCP DEFINE CIRCUIT DMC-0 COST 2
$       NCP DEFINE CIRCUIT DMC-0 HELLO TIMER 15
$       NCP DEFINE CIRCUIT DMC-0 LISTEN TIMER 240
$       NCP DEFINE CIRCUIT DMC-0 COUNTER TIMER 65535
$       NCP DEFINE CIRCUIT DMC-0 SERVICE ENABLE
$       NCP DEFINE CIRCUIT DMC-0 STATE ON
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Define connecting line (56kb DMC-11)                           !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$       NCP DEFINE LINE DMC-1 PROTOCOL DDCMP DMC
$       NCP DEFINE LINE DMC-1 CONTROLLER NORMAL
$       NCP DEFINE LINE DMC-1 COUNTER TIMER 65535
$       NCP DEFINE LINE DMC-1 DUPLEX FULL
$       NCP DEFINE LINE DMC-1 NORMAL TIMER 30000
$       NCP DEFINE LINE DMC-1 RECEIVE BUFFERS 16
$       NCP DEFINE LINE DMC-1 SERVICE TIMER 30000
$       NCP DEFINE LINE DMC-1 STATE ON
$
$       NCP DEFINE CIRCUIT DMC-1 COST 2
$       NCP DEFINE CIRCUIT DMC-1 HELLO TIMER 15
$       NCP DEFINE CIRCUIT DMC-1 LISTEN TIMER 240
$       NCP DEFINE CIRCUIT DMC-1 COUNTER TIMER 65535
$       NCP DEFINE CIRCUIT DMC-1 SERVICE ENABLE
$       NCP DEFINE CIRCUIT DMC-1 STATE ON
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Define connecting line (1 MB DMC-11)                           !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$       NCP DEFINE LINE DMC-2 PROTOCOL DDCMP DMC
$       NCP DEFINE LINE DMC-2 CONTROLLER NORMAL
$       NCP DEFINE LINE DMC-2 COUNTER TIMER 65535
$       NCP DEFINE LINE DMC-2 DUPLEX FULL
$       NCP DEFINE LINE DMC-2 NORMAL TIMER 30000
$       NCP DEFINE LINE DMC-2 RECEIVE BUFFERS 16
$       NCP DEFINE LINE DMC-2 SERVICE TIMER 30000
$       NCP DEFINE LINE DMC-2 STATE ON
$
$       NCP DEFINE CIRCUIT DMC-2 COST 1
$       NCP DEFINE CIRCUIT DMC-2 HELLO TIMER 15
$       NCP DEFINE CIRCUIT DMC-2 LISTEN TIMER 240
$       NCP DEFINE CIRCUIT DMC-2 COUNTER TIMER 65535
$       NCP DEFINE CIRCUIT DMC-2 SERVICE ENABLE
$       NCP DEFINE CIRCUIT DMC-2 STATE ON
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Define connecting line (1200/2400/4800/9600 BAUD DMC-11 DIALIN)!
$ !                                                                    !
$ !--------------------------------------------------------------------!
$       NCP DEFINE LINE DMC-3 PROTOCOL DDCMP DMC
$       NCP DEFINE LINE DMC-3 CONTROLLER NORMAL
$       NCP DEFINE LINE DMC-3 COUNTER TIMER 65535
$       NCP DEFINE LINE DMC-3 DUPLEX HALF
$       NCP DEFINE LINE DMC-3 NORMAL TIMER 30000
$       NCP DEFINE LINE DMC-3 RECEIVE BUFFERS 16
$       NCP DEFINE LINE DMC-3 SERVICE TIMER 30000
$       NCP DEFINE LINE DMC-3 STATE ON
$
$       NCP DEFINE CIRCUIT DMC-3 COST 25
$       NCP DEFINE CIRCUIT DMC-3 HELLO TIMER 60
$       NCP DEFINE CIRCUIT DMC-3 LISTEN TIMER 240
$       NCP DEFINE CIRCUIT DMC-3 COUNTER TIMER 65535
$       NCP DEFINE CIRCUIT DMC-3 SERVICE ENABLE
$       NCP DEFINE CIRCUIT DMC-3 STATE ON
$ !
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !                                                                    !
$ !     Enable local and remote nodes                                  !
$ !                                                                    !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$       WRITE SYS$OUTPUT " "
$       WRITE SYS$OUTPUT "***  Starting reconfigured network  ***"
$ 
$       @MKG$NETWORK:NETBOOT
$
$       WRITE SYS$OUTPUT " "
$       WRITE SYS$OUTPUT "***  Network configuration complete  ***"
$       WRITE SYS$OUTPUT " "
$ !------------------------------------------------------------------!
$ !     End of DECnet Executor Configuration Procedure               !
$ !------------------------------------------------------------------!
