$       IF (F$MODE() .NES. "INTERACTIVE") THEN SET NOVERIFY
$ !--------------------------------------------------------------------!
$ !     Procedure:     NETBOOT                                         !
$ !--------------------------------------------------------------------!
$ !     System:        VAX/VMS V3.0 DCL                                !
$ !--------------------------------------------------------------------!
$ !     Programmer:    Kevin Klughart                                  !
$ !--------------------------------------------------------------------!
$ !     Date:          05-12-83 @ 14:00 CDST                           !
$ !--------------------------------------------------------------------!
$ !     Purpose:       VMS command procedure to load network drivers   !
$ !                    and create create remote device ACP server.     !
$ !                    Global network parameters are reloaded at each  !
$ !                    system startup or during each reconfiguration.  !
$ !                                                                    !
$ !     ***  This file is under network configuration control  ***     !
$ !--------------------------------------------------------------------!
$ !     Initialize error condition processors                          !
$ !--------------------------------------------------------------------!
$       ON ERROR     THEN EXIT
$       ON CONTROL_Y THEN EXIT
$
$       IF (F$MODE() .NES. "INTERACTIVE") THEN $WAIT 00:01:00
$ !--------------------------------------------------------------------!
$ !     Determine if network parameters are to be SET or DEFINED       !
$ !--------------------------------------------------------------------!
$       MODE = "DEFINE"
$       IF (P1 .NES. "") THEN MODE = "SET"
$ !--------------------------------------------------------------------!
$ !     Determine if the process has sufficient privileges to boot net !
$ !--------------------------------------------------------------------!
$       REQ_PRIV = "ACNT,DETACH,CMKRNL,LOG_IO,NETMBX,TMPMBX,SYSNAM,SYSPRV"
$       CUR_PRIV = F$SETPRV(REQ_PRIV)
$       IF (F$PRIVILEGE(REQ_PRIV)) THEN GOTO BOOT
$
$       WRITE SYS$OUTPUT "***  Insufficient privileges to boot network  ***"
$       WRITE SYS$OUTPUT "***  Requires ",REQ_PRIV," privileges  ***"
$       CUR_PRIV = F$SETPRV(CUR_PRIV)
$       EXIT
$ !
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !                                                                    !
$ !     Process privileges are sufficient.  Boot the network.          !
$ !                                                                    !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Connect the network driver and remote terminal ACP driver      !
$ !--------------------------------------------------------------------!
$ BOOT: RUN SYS$SYSTEM:SYSGEN
                CONNECT NET  /NOADAPTER /DRIVER=NETDRIVER
                CONNECT RTA0 /NOADAPTER /DRIVER=RTTDRIVER
$ !--------------------------------------------------------------------!
$ !     Define the network configuration program and install it        !
$ !--------------------------------------------------------------------!
$       NCP :== $ NCP
$
$       RUN SYS$SYSTEM:INSTALL
                SYS$SYSTEM:NCP /OPEN /SHARED /HEADER_RESIDENT
$ !
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !                                                                    !
$ !     M O S T E K   N E T W O R K   N O D E   D E F I N I T I O N S  !
$ !                                                                    !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !                                                                    !
$ !     REMOTE NODE DEFINITIONS                                        !
$ !                                                                    !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote PDP-11/23 system "CAMKT1"           !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Computer Aids to Manufacturing Keithley R&D Tester #1          !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 001 -
                ADDRESS 001 -
                NAME CAMKT1 -
                CPU PDP11     -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote VAX-11/780 system "CADEGR"          !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Computer Aids To Design Engineering Development System         !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 002 -
                ADDRESS 002 -
                NAME CADEGR -
                CPU VAX     -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote VAX-11/780 system "CADGPX"          !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Computer Aids To Design Graphics Development System            !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 003 -
                ADDRESS 003 -
                NAME CADGPX -
                CPU VAX     -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote PDP-11/60 system "CADRJE"           !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Computer Aids To Design CDC CYBER 203/205 XRB Workstation      !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 004 -
                ADDRESS 004 -
                NAME CADRJE -
                CPU PDP11   -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote PDP-11/34 system "CADCYB"           !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Computer Aids To Design CDC CYBER 203/205 XRB Workstation      !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 005 -
                ADDRESS 005 -
                NAME CADCYB -
                CPU PDP11   -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote PDP-11/34 APPLICON system "CADAPH"  !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Computer Aids To Design Applicon Graphics System - "H"         !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 006 -
                ADDRESS 006 -
                NAME CADAPH -
                CPU PDP11   -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote PDP-11/34 APPLICON system "CADAPG"  !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Computer Aids To Design Applicon Graphics System - "G"         !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 007 -
                ADDRESS 007 -
                NAME CADAPG -
                CPU PDP11   -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote PDP-11/34 APPLICON system "CADAPB"  !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Computer Aids To Design Applicon Graphics System - "B"         !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 008 -
                ADDRESS 008 -
                NAME CADAPB -
                CPU PDP11   -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote VAX-11/780 system "CAMVAX"          !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Crosby I Computer Aids to Manufacturing VAX                    !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 009 -
                ADDRESS 009 -
                NAME CAMVAX -
                CPU VAX     -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote PDP-11/70 system "CAMHST"           !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Crosby I Computer Aids to Manufacturing Host 11/70             !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 010 -
                ADDRESS 010 -
                NAME CAMHST -
                CPU PDP11   -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER IASBATCH PASSWORD MOSTEK
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote PDP-11/34 system "CAMST1"           !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Crosby I Computer Aids to Manufacturing 11/34                  !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 011 -
                ADDRESS 011 -
                NAME CAMST1 -
                CPU PDP11   -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote PDP-11/34 system "CAMST2"           !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Crosby I Computer Aids to Manufacturing 11/34                  !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 012 -
                ADDRESS 012 -
                NAME CAMST2 -
                CPU PDP11   -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote PDP-11/34 system "CAMST3"           !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Crosby I Computer Aids to Manufacturing 11/34                  !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 013 -
                ADDRESS 013 -
                NAME CAMST3 -
                CPU PDP11   -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote PDP-11/44 system "CAMST4"           !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Crosby I Computer Aids to Manufacturing 11/44                  !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 014 -
                ADDRESS 014 -
                NAME CAMST4 -
                CPU PDP11   -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote PDP-11/70 system "PENANG"           !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Penang Computer Aids to Manufacturing 11/70 Supervisory System !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 015 -
                ADDRESS 015 -
                NAME PENANG -
                CPU PDP11   -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER IASBATCH PASSWORD MOSTEK ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote PDP-11/34 system "PENSUP"           !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Penang Computer Aids to Manufacturing 11/34 Supervisory System !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 016 -
                ADDRESS 016 -
                NAME PENSUP -
                CPU PDP11   -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER IASBATCH PASSWORD MOSTEK ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote VAX-11/780 system "ALPD01"          !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Array Logic Products Design                                    !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 017 -
                ADDRESS 017 -
                NAME ALPD01 -
                CPU VAX     -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote PDP-11/34 system "TSIHST"           !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Test Systems Integration Main Host Software Development System !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 018 -
                ADDRESS 018 -
                NAME TSIHST -
                CPU PDP11   -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote PDP-11/34 system "TSIDT1"           !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Test Systems Integration Down Time Tracking Station            !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 019 -
                ADDRESS 019 -
                NAME TSIDT1 -
                CPU PDP11   -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote PDP-11/23 system "TSIPRD"           !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Test Systems Integration Production Terminal System            !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 020 -
                ADDRESS 020 -
                NAME TSIPRD -
                CPU PDP11   -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote VAX-11/780 system "CMS"             !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Central Marketing (MOSIS)                                      !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 021 -
                ADDRESS 021 -
                NAME CMS    -
                CPU VAX     -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote VAX-11/780 system "OPSPLN"          !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Operations Planning Systems Planning VAX                       !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 022 -
                ADDRESS 022 -
                NAME OPSPLN -
                CPU VAX     -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote PDP-11/23 system "CAMKT2"           !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Computer Aids to Manufacturing Keithley R&D Tester #2          !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 023 -
                ADDRESS 023 -
                NAME CAMKT2 -
                CPU  PDP11  -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote PDP-11/23 system "CAMKT3"           !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Computer Aids to Manufacturing Keithley R&D Tester #3          !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 024 -
                ADDRESS 024 -
                NAME CAMKT3 -
                CPU  PDP11  -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote VAX-11/780 system "CSP"             !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Colorado Springs Mostek VAX                                    !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 025 -
                ADDRESS 025 -
                NAME CSP    -
                CPU VAX     -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote PDP-11/44 system "CSPSUP"           !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Colorado Springs Supervisory                                   !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 026 -
                ADDRESS 026 -
                NAME CSPSUP -
                CPU PDP11   -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote VAX-11/780 system "UTMC01"          !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     UTMC Colorado Springs                                          !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 027 -
                ADDRESS 027 -
                NAME UTMC01 -
                CPU VAX     -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote VAX-11/780 system "UTMC02"          !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     UTMC Colorado Springs                                          !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 028 -
                ADDRESS 028 -
                NAME UTMC02 -
                CPU VAX     -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote VAX-11/750 system "UTBS50"          !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     United Technologies Building Systems VAX-11/750 (Los Colinas)  !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 029 -
                ADDRESS 029 -
                NAME UTBS50 -
                CPU VAX     -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote VAX-11/780 system "UTBS80"          !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     United Technologies Building Systems VAX-11/780 (Los Colinas)  !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 030 -
                ADDRESS 030 -
                NAME UTBS80 -
                CPU VAX     -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote VAX-11/780 system "IRE"             !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Ireland VAX                                                    !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 031 -
                ADDRESS 031 -
                NAME IRE    -
                CPU VAX     -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Node definition for remote PDP-11/70 system "IRESUP"           !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' NODE 032 -
                ADDRESS 032 -
                NAME IRESUP -
                CPU PDP11   -
                COUNTER TIMER 65535 -
                NONPRIVILEGED USER NETUSR PASSWORD NETUSR ACCOUNT DECNET
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !                                                                    !
$ !     End of Mostek network node configuration database              !
$ !                                                                    !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$       IF (MODE .EQS. "SET") THEN EXIT
$ !
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !                                                                    !
$ !     Define logging monitor transmitter and receiver sinks          !
$ !                                                                    !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' LOGGING MONITOR KNOWN EVENTS
$       NCP 'MODE' LOGGING MONITOR STATE ON
$
$       NCP 'MODE' LOGGING CONSOLE KNOWN EVENTS
$       NCP 'MODE' LOGGING CONSOLE STATE ON
$ !
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !                                                                    !
$ !                                                                    !
$ !     Define network executive objects                               !
$ !                                                                    !
$ !                                                                    !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Define file access listener object                             !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' OBJECT FAL FILE FAL NUMBER 17
$ !--------------------------------------------------------------------!
$ !     Define host loader object                                      !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' OBJECT HLD FILE HLD NUMBER 18
$ !--------------------------------------------------------------------!
$ !     Define network management listener object                      !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' OBJECT NML FILE NML NUMBER 19 PRIVILEGES DIAGNOSE OPER
$ !--------------------------------------------------------------------!
$ !     Define remote terminal acp control object                      !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' OBJECT REMACP FILE REMACP NUMBER 23
$ !--------------------------------------------------------------------!
$ !     Define loopback mirror object                                  !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' OBJECT MIRROR FILE MIRROR NUMBER 25
$ !--------------------------------------------------------------------!
$ !     Define event logger object                                     !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' OBJECT EVL FILE EVL NUMBER 26
$ !--------------------------------------------------------------------!
$ !     Define MAIL utility object                                     !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' OBJECT MAIL FILE MAIL NUMBER 27
$ !--------------------------------------------------------------------!
$ !     Define PHONE utility object                                    !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' OBJECT PHONE FILE PHONE NUMBER 29
$ !--------------------------------------------------------------------!
$ !     Define DDTR Datatrieve remote server utility object            !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' OBJECT DDTR FILE DDTR NUMBER 30
$ !--------------------------------------------------------------------!
$ !     Define DECnet test receiver object                             !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' OBJECT DTR FILE DTR NUMBER 63
$ !--------------------------------------------------------------------!
$ !     Define DECnet remote print server utility object               !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' OBJECT REMPRT FILE REMPRT NUMBER 128
$ !--------------------------------------------------------------------!
$ !     Define DECnet remote DCL server utility object                 !
$ !--------------------------------------------------------------------!
$       NCP 'MODE' OBJECT REMDCL FILE REMDCL NUMBER 129
$ !
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !                                                                    !
$ !     Start the local node network and all remote DECnet lines       !
$ !                                                                    !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$       NCP SET EXECUTOR ALL
$       NCP SET KNOWN OBJECTS ALL
$       NCP SET KNOWN LOGGING ALL
$       NCP SET KNOWN LINES ALL
$       NCP SET KNOWN CIRCUITS ALL
$       NCP SET KNOWN NODES ALL
$ !
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !                                                                    !
$ !     Start the remote network terminal ACP                          !
$ !                                                                    !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Wait for network to initialize before initializing ACP         !
$ !--------------------------------------------------------------------!
$       WAIT 00:00:15
$
$       RUN SYS$SYSTEM:REMACP -
                /NOACCOUNTING-
                /AST_LIMIT=100-
                /NOAUTHORIZE-
                /BUFFER_LIMIT=65535 -
                /FILE_LIMIT=70-
                /IO_BUFFERED=65535 -
                /PRIORITY=8-
                /PRIVILEGES=(CMKRNL,LOG_IO,NETMBX,TMPMBX,SYSNAM)-
                /PROCESS_NAME=REMACP-
                /UIC=[1,3]
$ !--------------------------------------------------------------------!
$ !     Install remote terminal packet assembler/disassembler with     !
$ !     logical I/O privilege to prevent ^Y link abort problems.       !
$ !--------------------------------------------------------------------!
$       RUN SYS$SYSTEM:INSTALL
                SYS$SYSTEM:RTPAD        /PRIVILEGED=(LOG_IO)
$ !--------------------------------------------------------------------!
$ !     End of network initialization                                  !
$ !--------------------------------------------------------------------!
