$ !--------------------------------------------------------------------!
$ !     Procedure:     NETPRT                                          !
$ !--------------------------------------------------------------------!
$ !     System:        VAX/VMS V3.0 DCL                                !
$ !--------------------------------------------------------------------!
$ !     Programmer:    Kevin Klughart                                  !
$ !--------------------------------------------------------------------!
$ !     Date:          04-18-83 @ 06:00 CDST                           !
$ !--------------------------------------------------------------------!
$ !     Purpose:       VMS command procedure to serve remote print     !
$ !                    requests.  Copies remote file to NET$PRINT.     !
$ !                                                                    !
$ !     ***  This file is under network configuration control  ***     !
$ !--------------------------------------------------------------------!
$ !     Initialize error condition processors                          !
$ !--------------------------------------------------------------------!
$       ON ERROR     THEN EXIT
$       ON CONTROL_Y THEN EXIT
$ !
$ !--------------------------------------------------------------------!
$ !     Validate remote node name (first parameter)                    !
$ !--------------------------------------------------------------------!
$ NOD:  NODENAME = "''P1'"
$       IF (NODENAME .EQS. "") THEN GOTO ENOD
$
$ !--------------------------------------------------------------------!
$ !     Search for remote node name in "show network" listing          !
$ !--------------------------------------------------------------------!
$       ASSIGN /USER_MODE NETPRT.TMP SYS$OUTPUT
$       SHOW NETWORK
$       OPEN /READ NODES  NETPRT.TMP
$ NEXT: READ /END_OF_FILE=EOF NODES RECORD
$       IF (F$LOCATE(NODENAME,RECORD) .NE. F$LENGTH(RECORD)) THEN GOTO DONE
$       GOTO NEXT
$
$ EOF:  CLOSE NODES
$ ENOD: WRITE SYS$OUTPUT " "
$       INQUIRE P1 "Enter remote node name"
$       GOTO NOD
$
$ DONE: CLOSE NODES
$       DELETE NETPRT.TMP;*
$ !
$ !--------------------------------------------------------------------!
$ !     Validate filename of file to be printed (second parameter)     !
$ !--------------------------------------------------------------------!
$ FIL:  FILENAME = "''P2'"
$       IF (FILENAME .EQS. "") THEN GOTO EFIL
$
$       FILENAME = F$PARSE(FILENAME,".LIS")
$       FILENAME = F$SEARCH(FILENAME)
$       IF (FILENAME .NES. "") THEN GOTO MODE
$
$ EFIL: WRITE SYS$OUTPUT " "
$       INQUIRE P2 "Enter name of file to be printed"
$       GOTO FIL
$ !
$ !--------------------------------------------------------------------!
$ !     Submit via batch queue if current mode interactive             !
$ !--------------------------------------------------------------------!
$ MODE: IF (F$MODE() .EQS. "BATCH") THEN GOTO COPY
$       SUBMIT MKG$NETWORK:NETPRT /NOTIFY /NOLOG /NOPRINTER -
                /PARAMETERS=('NODENAME','FILENAME')
$       EXIT
$ !
$ !--------------------------------------------------------------------!
$ !     Open remote channel to remote node and copy file               !
$ !--------------------------------------------------------------------!
$ COPY: OPEN /WRITE     REMOTE 'NODENAME'::"TASK=REMPRT"
$
$            COPY 'FILENAME' REMOTE
$
$       CLOSE           REMOTE
$ !--------------------------------------------------------------------!
$ !     End of main procedure NETPRT                                   !
$ !--------------------------------------------------------------------!
