$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !                                                                    !
$ !                                                                    !
$ !     T  E  L  E  X      I  N  I  T  I  A  L  I  Z  A  T  I  O  N    !
$ !                                                                    !
$ !                                                                    !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !                                                                    !
$ !     Define TELEX related logical names and process symbols         !
$ !                                                                    !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Define the root directory in which all Telex directories reside!
$ !--------------------------------------------------------------------!
$       DEFINE TLX$SYSROOT _'F$GETDVI("SYS$DISK","DEVNAM")'[TELEX.]
$ !--------------------------------------------------------------------!
$ !     Define the server Telex terminal port and the server node name !
$ !     The port name is defined for only the server node, that is     !
$ !     the node on which the Telex communication sofware resides.     !
$ !     All other nodes on the network communicate to this server node !
$ !     and transmit data via DECnet.  The server node specification   !
$ !     indicates which node on the network is the "gateway" to the    !
$ !     Telex processor.  Only one server is allowed per network.      !
$ !--------------------------------------------------------------------!
$       ASSIGN        _TTA1:                    TLX$PORT:
$       ASSIGN        'F$LOGICAL("SYS$NODE")'   TLX$SERVER:
$ !--------------------------------------------------------------------!
$ !     Define the Telex subdirectories based on functional content.   !
$ !     Each logical name must also have a corresponding "set default" !
$ !     command as defined below.                                      !
$ !--------------------------------------------------------------------!
$       ASSIGN        TLX$SYSROOT:[TLXCOM]      TLX$COMMAND:
$       ASSIGN        TLX$SYSROOT:[TLXEXE]      TLX$SYSTEM:
$       ASSIGN        TLX$SYSROOT:[TLXFRM]      TLX$FORMS:
$       ASSIGN        TLX$SYSROOT:[TLXHLP]      TLX$HELP:
$       ASSIGN        TLX$SYSROOT:[TLXLIB]      TLX$LIBRARY:
$       ASSIGN        TLX$SYSROOT:[TLXLIS]      TLX$LIST:
$       ASSIGN        TLX$SYSROOT:[TLXLOG]      TLX$BATCHLOG:
$       ASSIGN        TLX$SYSROOT:[TLXMAC]      TLX$MACROS:
$       ASSIGN        TLX$SYSROOT:[TLXOBJ]      TLX$OBJECT:
$       ASSIGN        TLX$SYSROOT:[TLXSCR]      TLX$SCRATCH:
$       ASSIGN        TLX$SYSROOT:[TLXSPM]      TLX$STRUCTURED_MACROS:
$       ASSIGN        TLX$SYSROOT:[TLXSRC]      TLX$SOURCE:
$ !--------------------------------------------------------------------!
$ !     Define development directory movement commands                 !
$ !     Note the one-to-one mapping of the following commands to the   !
$ !     logical names in the section above.                            !
$ !--------------------------------------------------------------------!
$       TLXMFD    :== "SET DEFAULT [-]"
$       TLXCOM    :== "SET DEFAULT TLX$COMMAND:"
$       TLXEXE    :== "SET DEFAULT TLX$SYSTEM:"
$       TLXFRM    :== "SET DEFAULT TLX$FORMS:"
$       TLXHLP    :== "SET DEFAULT TLX$HELP:"
$       TLXLIB    :== "SET DEFAULT TLX$LIBRARY:"
$       TLXLIS    :== "SET DEFAULT TLX$LIST:"
$       TLXLOG    :== "SET DEFAULT TLX$BATCHLOG:"
$       TLXMAC    :== "SET DEFAULT TLX$MACROS:"
$       TLXOBJ    :== "SET DEFAULT TLX$OBJECT:"
$       TLXSCR    :== "SET DEFAULT TLX$SCRATCH:"
$       TLXSPM    :== "SET DEFAULT TLX$STRUCTURED_MACROS:"
$       TLXSRC    :== "SET DEFAULT TLX$SOURCE:"
$ !--------------------------------------------------------------------!
$ !     Define special symbols for Telex image execution               !
$ !--------------------------------------------------------------------!
$       TLX       :== $TLX$SYSTEM:TLX
$       TLXRUN    :== "RUN TLX$SYSTEM:"
$
$       BLD       :== "@TLX$COMMAND:TLXBLD"
$       FLB       :== "@TLX$COMMAND:TLXFLB"
$       LNK       :== "@TLX$COMMAND:TLXLNK"
$       MAR       :== "@TLX$COMMAND:TLXMAR"
$       MLB       :== "@TLX$COMMAND:TLXMLB"
$       SPM       :== "@TLX$COMMAND:TLXSPM"
$ !--------------------------------------------------------------------!
$ !     End of Telex initialization procedure                          !
$ !--------------------------------------------------------------------!
