$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !                                                                    !
$ !     TLXMAR - Assemble Telex Source Modules                         !
$ !                                                                    !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Save current process name for later restoration                !
$ !--------------------------------------------------------------------!
$       PRCNAM = F$GETJPI("","PRCNAM")
$ !--------------------------------------------------------------------!
$ !     If first parameter is present, use it as module name           !
$ !--------------------------------------------------------------------!
$       MODULE = "''P1'"
$       IF (MODULE .EQS. "") THEN GOTO ALL
$ !--------------------------------------------------------------------!
$ !     Append Telex program prefix for three character module names   !
$ !--------------------------------------------------------------------!
$       LENGTH = F$LENGTH(MODULE)
$       IF (F$LOCATE("TLX",MODULE) .EQ. LENGTH) THEN MODULE = "TLX"+MODULE
$ !
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Submit as a batch job if current mode is interactive           !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$       IF (F$MODE() .NES. "INTERACTIVE") THEN GOTO MSG
$       IF (P2 .NES. "") THEN GOTO MSG
$
$       SUBMIT TLX$COMMAND:TLXMAR /NAME='MODULE' /PARAMETERS=('MODULE') -
                /NOTIFY /LOG_FILE=TLX$BATCHLOG: /NOPRINTER -
                /QUEUE=SYS$BATCH
$       EXIT
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Perform message assembly for message files                     !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ MSG:  LENGTH = F$LENGTH(MODULE)
$       IF (F$LOCATE("MSG",MODULE) .EQ. LENGTH) THEN GOTO ASM
$       SET PROCESS /NAME="''MODULE'_Message"
$
$       MESSAGE TLX$SOURCE:'MODULE'.MAR -
                /LIST=TLX$LIST:'MODULE' /OBJECT=TLX$OBJECT:'MODULE'
$
$       GOTO DONE
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Assemble the module, directing listings and object files       !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ ASM:  SET PROCESS /NAME="''MODULE'_Macro"
$
$       MACRO   TLX$SOURCE:'MODULE'        + -
                TLX$LIBRARY:TELEX /LIBRARY + -
                TLX$LIBRARY:TDSPM /LIBRARY + -
                SYS$LIBRARY:LIB   /LIBRARY   -
                /LIST=TLX$LIST:'MODULE' /OBJECT=TLX$OBJECT:'MODULE'
$
$       GOTO DONE
$ !
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     If first parameter is missing, assemble all modules            !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ !     Obtain a list of all source modules and assemble them          !
$ !     Assembly will occur in alphabetical order, all modules included!
$ !--------------------------------------------------------------------!
$ ALL:  MODULE = F$SEARCH("TLX$SOURCE:*.MAR;")
$       IF (MODULE .EQS. "") THEN GOTO DONE
$
$       MODULE = F$EXTRACT(F$LOCATE("]",MODULE)+1,F$LENGTH(MODULE),MODULE)
$       MODULE = F$EXTRACT(0,F$LOCATE(".",MODULE),MODULE)
$
$       SUBMIT TLX$COMMAND:TLXMAR /NAME='MODULE' /PARAMETERS=('MODULE') -
                /NOTIFY /LOG_FILE=TLX$BATCHLOG: /NOPRINTER -
                /QUEUE=SYS$BATCH
$       GOTO ALL
$ !
$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !     Now that assembly is complete, purge unnecessary files         !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$ DONE: PURGE TLX$OBJECT:*.*
$       PURGE TLX$LIST:*.*
$
$       SET PROCESS /NAME="''PRCNAM'"
$ !--------------------------------------------------------------------!
$ !     End of Telex assembly procedure                                !
$ !--------------------------------------------------------------------!
