$ !--------------------------------------------------------------------!
$ !                                                                    !
$ !                                                                    !
$ !     TLXSPM - Create top-down structured programming macro library  !
$ !                                                                    !
$ !                                                                    !
$ !--------------------------------------------------------------------!
$       IF (P1 .EQS. "") THEN GOTO ALL
$       FILE = F$PARSE(P1,"TLX$STRUCTURED_MACROS:.MAR")
$       GOTO NEXT
$ !--------------------------------------------------------------------!
$ !     Create the new macro library using all macro definition files  !
$ !--------------------------------------------------------------------!
$ !     CASE   - CASE construct                                        !
$ !     IF     - IF-THEN-ELSE construct                                !
$ !     LABEL  - Unique label generation and definition macros         !
$ !     LOOP   - LOOP-EXITIF-ENDLOOP construct                         !
$ !     REPEAT - REPEAT-UNTIL construct                                !
$ !     STACK  - Assembly stack manipulation macros                    !
$ !     STRING - Assembly string manipulation macros                   !
$ !     WHILE  - WHILE-ENDWHILE construct                              !
$ !--------------------------------------------------------------------!
$ ALL:  DELETE    TLX$LIBRARY:TDSPM.MLB;*
$       LIBRARIAN TLX$LIBRARY:TDSPM /CREATE /MACRO
$       FILE =    "TLX$STRUCTURED_MACROS:*.MAR;"
$
$
$ NEXT: MODULE = F$SEARCH(FILE)
$       IF (MODULE .EQS. "") THEN EXIT
$
$       WRITE SYS$OUTPUT "***  Entering SPM module ",MODULE
$       LIBRARIAN TLX$LIBRARY:TDSPM.MLB 'MODULE'
$       IF (P1 .EQS. "") THEN GOTO NEXT
$ !--------------------------------------------------------------------!
$ !     End of TDSPM Macro Library creation procedure                  !
$ !--------------------------------------------------------------------!
